<?php
namespace Planejamento\Repositories;

class Restembtpprat extends \Doctrine\ORM\EntityRepository
{
    public static function DeletaRestricao($nrrestembtpprat){
        $sql = <<<SQL
DELETE FROM RESTEMBTPPRAT
WHERE NRRESTEMBTPPRAT = :NRRESTEMBTPPRAT
SQL;
        $params = array(
            'NRRESTEMBTPPRAT' =>$nrrestembtpprat
        );

        try{
            $conn = \Setforms2\Runtime\Connection::getInstance();
            $conn->execute($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public static function DeletaItemRestricao($nrrestembtpprat, $cdcontainer){
        $sql = <<<SQL
DELETE FROM ITRESTEMBTPPRAT
WHERE NRRESTEMBTPPRAT=:NRRESTEMBTPPRAT AND
CDCONTAINER=:CDCONTAINER
SQL;
        $params = array(
            'NRRESTEMBTPPRAT' =>$nrrestembtpprat,
            'CDCONTAINER'     =>$cdcontainer
        );

        try{
            $conn = \Setforms2\Runtime\Connection::getInstance();
            $conn->execute($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public static function InsereRestricao($nrrestembtpprat,$cdfilial, $cdservfili, $nrseqcnfcard, $cdcliente, $cddestfili){
        $sql = <<<SQL
INSERT INTO RESTEMBTPPRAT
(NRRESTEMBTPPRAT, CDFILIAL, CDSERVFILI, NRSEQCNFCARD, CDCLIENTE, CDDESTFILI)
VALUES
('$nrrestembtpprat', '$cdfilial', '$cdservfili', '$nrseqcnfcard', '$cdcliente', '$cddestfili')

SQL;

        try{
            $conn = \Setforms2\Runtime\Connection::getInstance();
            $conn->execute($sql);
        } catch (\Exception $e) {
            throw $e;
        }

    }

    public static function InsereItemRestricao($nrrestembtpprat, $cdcontainer, $vrmincontainer, $nrordem){
        $sql = <<<SQL
INSERT INTO ITRESTEMBTPPRAT
(NRRESTEMBTPPRAT, CDCONTAINER, VRMINCONTAINER, NRORDEM)
VALUES
('$nrrestembtpprat', '$cdcontainer', '$vrmincontainer', '$nrordem')
SQL;

        try{
            $conn = \Setforms2\Runtime\Connection::getInstance();
            $conn->execute($sql);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    /**
     * Antes de inserir busca a restricao a ser inserida no banco para que restricoes iguais para o mesmo tipo de prato nao seja inseridas.
     * @param $cdfilial
     * @param $cdservfili
     * @param $nrseqcnfcard
     * @param $cdcliente
     * @param $cddestfili
     * @param $cdcontainer
     * @param $nrorg
     * @throws \Exception
     */
    public static function BuscaItemRestricao($cdfilial, $cdservfili, $nrseqcnfcard, $cdcliente, $cddestfili, $cdcontainer, $nrorg){
        $sql = <<<SQL
SELECT RE.CDFILIAL, RE.NRSEQCNFCARD, RE.CDSERVFILI, RE.CDCLIENTE, RE.CDDESTFILI, IT.CDCONTAINER   FROM RESTEMBTPPRAT RE
LEFT JOIN ITRESTEMBTPPRAT IT ON IT.NRRESTEMBTPPRAT= RE.NRRESTEMBTPPRAT AND IT.NRORG = RE.NRORG
WHERE RE.CDFILIAL =:CDFILIAL AND
RE.NRSEQCNFCARD   =:NRSEQCNFCARD AND
RE.CDSERVFILI     =:CDSERVFILI AND
(((:CDCLIENTE IS NULL) AND (RE.CDCLIENTE IS NULL)) OR
	      (RE.CDCLIENTE = :CDCLIENTE AND
	      RE.CDDESTFILI = :CDDESTFILI)) AND
        IT.CDCONTAINER =:CONTAINER AND
        IT.NRORG=:NRORG
SQL;

        $params = array(
            'CDFILIAL'        =>$cdfilial,
            'CDSERVFILI'      =>$cdservfili,
            'NRSEQCNFCARD'    =>$nrseqcnfcard,
            'CDCLIENTE'       =>$cdcliente,
            'CDDESTFILI'      =>$cddestfili,
            'CONTAINER'       =>$cdcontainer,
            'NRORG'           =>$nrorg
        );


        try{
            $conn = \Setforms2\Shared\Registry::getEntityManager();
            $conn = $conn->getConnection();
            return $conn-> fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public static function BuscaNumeroRestricao($cdfilial, $cdservfili, $nrseqcnfcard, $cdcliente, $cddestfili,$nrorg){
        $sql= <<<SQL
SELECT NRRESTEMBTPPRAT
FROM RESTEMBTPPRAT
WHERE CDFILIAL       =:CDFILIAL
AND CDSERVFILI       =:CDSERVFILI
AND (((:CDCLIENTE IS NULL)
AND (CDCLIENTE      IS NULL))
OR (CDCLIENTE        = :CDCLIENTE
AND CDDESTFILI       = :CDDESTFILI))
AND NRORG            =:NRORG
AND NRSEQCNFCARD     =:NRSEQCNFCARD
SQL;
        $params = array(
            'CDFILIAL'        =>$cdfilial,
            'CDSERVFILI'      =>$cdservfili,
            'NRSEQCNFCARD'    =>$nrseqcnfcard,
            'CDCLIENTE'       =>$cdcliente,
            'CDDESTFILI'      =>$cddestfili,
            'NRORG'           =>$nrorg
        );

        try{
            $conn = \Setforms2\Shared\Registry::getEntityManager();
            $conn = $conn->getConnection();
            return $conn-> fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }

    }

    public static function AtualizaRestricao($nrrestembtpprat, $cdcontainer, $vrmincontainer, $nrordem){
        $sql = <<<SQL
UPDATE ITRESTEMBTPPRAT
SET VRMINCONTAINER = '$vrmincontainer',
        NRORDEM = '$nrordem'
WHERE NRRESTEMBTPPRAT = '$nrrestembtpprat' AND
               CDCONTAINER = '$cdcontainer'
SQL;
        $params = array(
            'NRRESTEMBTPPRAT' =>$nrrestembtpprat,
            'CDCONTAINER'        =>$cdcontainer,
            'VRMINCONTAINER'     =>$vrmincontainer,
            'NRORDEM'            =>$nrordem
        );

        try{
            $conn = \Setforms2\Runtime\Connection::getInstance();
            $conn->execute($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }

    }

    public static function BuscaNrCategoriaEmabalagem($cdcategoria){
        $sql = <<<SQL
SELECT NRCATEMBALAG FROM CATEMBALAG WHERE CDCATEMBALAG =:CDCATEMBALAG
SQL;
        $params = array(
            'CDCATEMBALAG'=>$cdcategoria

        );

        try{
            $conn = \Setforms2\Shared\Registry::getEntityManager();
            $conn = $conn->getConnection();
            return $conn-> fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }

    }

    public static function ConfereRestricaoImportada($cdfilial, $cdservfili, $cdcliente, $cddestfili){
        $sql = <<<SQL
SELECT NRRESTEMBTPPRAT
FROM RESTEMBTPPRAT
WHERE CDFILIAL = :P_CDFILIAL AND
	   CDSERVFILI = :P_CDSERVFILI AND
      (((:P_CDCLIENTE IS NULL) AND (CDCLIENTE IS NULL)) OR
	      (CDCLIENTE = :P_CDCLIENTE AND
	      CDDESTFILI = :P_CDDESTFILI)
      )
SQL;
        $params = array(
            'P_CDFILIAL'=>$cdfilial,
            'P_CDSERVFILI'=>$cdservfili,
            'P_CDCLIENTE'=>$cdcliente,
            'P_CDDESTFILI'=>$cddestfili

        );
        try{
            $conn = \Setforms2\Shared\Registry::getEntityManager();
            $conn = $conn->getConnection();
            return $conn-> fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public static function BuscaRestricoesOrigem($cdfilial, $cdservfili, $cdcliente, $cddestfili, $cdtipoprat){
        $sql = <<<SQL
SELECT C.CDTIPOPRAT, R.NRRESTEMBTPPRAT, C.NRORDCNFCARD
  FROM CONFCARD C
       LEFT JOIN RESTEMBTPPRAT R ON R.NRSEQCNFCARD = C.NRSEQCNFCARD AND
                                    R.CDFILIAL = C.CDFILIAL AND
                                    R.CDSERVFILI = C.CDSERVFILI AND
                                    ( ((:P_CDCLIENTE IS NULL) AND (R.CDCLIENTE IS NULL)) OR
	                                  (R.CDCLIENTE = :P_CDCLIENTE AND
	                                   R.CDDESTFILI = :P_CDDESTFILI) )

 WHERE C.CDFILIAL = :P_CDFILIAL
   AND C.CDSERVFILI = :P_CDSERVFILI
   AND R.NRRESTEMBTPPRAT IS NOT NULL
   AND ((INSTR(:CDTIPOPRAT,C.CDTIPOPRAT) <> 0) OR (:CDTIPOPRAT = 'A'))
ORDER BY CDTIPOPRAT, NRORDCNFCARD
SQL;
        $params = array(
            'P_CDFILIAL'=>$cdfilial,
            'P_CDSERVFILI'=>$cdservfili,
            'P_CDCLIENTE'=>$cdcliente,
            'P_CDDESTFILI'=>$cddestfili,
            'CDTIPOPRAT'=>$cdtipoprat

        );
        try{
            $conn = \Setforms2\Shared\Registry::getEntityManager();
            $conn = $conn->getConnection();
            return $conn-> fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public static function BuscaRestricoesOrigemNaoCadastrada($cdfilial, $cdservfili, $cdcliente, $cddestfili, $cdtpprato){
        $sql = <<<SQL
SELECT C.CDTIPOPRAT, R.NRRESTEMBTPPRAT, C.NRORDCNFCARD
  FROM CONFCARD C
       LEFT JOIN RESTEMBTPPRAT R ON R.NRSEQCNFCARD = C.NRSEQCNFCARD AND
                                    R.CDFILIAL = C.CDFILIAL AND
                                    R.CDSERVFILI = C.CDSERVFILI AND
                                    ( ((:P_CDCLIENTE IS NULL) AND (R.CDCLIENTE IS NULL)) OR
	                                  (R.CDCLIENTE = :P_CDCLIENTE AND
	                                   R.CDDESTFILI = :P_CDDESTFILI) )

 WHERE C.CDFILIAL = :P_CDFILIAL
   AND C.CDSERVFILI = :P_CDSERVFILI
   AND R.NRRESTEMBTPPRAT IS NULL
   AND ((INSTR(:CDTIPOPRAT,C.CDTIPOPRAT) <> 0) OR (:CDTIPOPRAT = 'A'))
ORDER BY CDTIPOPRAT, NRORDCNFCARD
SQL;
        $params = array(
            'P_CDFILIAL'=>$cdfilial,
            'P_CDSERVFILI'=>$cdservfili,
            'P_CDCLIENTE'=>$cdcliente,
            'P_CDDESTFILI'=>$cddestfili,
            'CDTIPOPRAT'=>$cdtpprato

        );
        try{
            $conn = \Setforms2\Shared\Registry::getEntityManager();
            $conn = $conn->getConnection();
            return $conn-> fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public static function BuscaRestricoesDeTipodePrato($cdfilial, $cdservfili, $cdcliente, $cddestfili, $nrrestembtpprat){
        $sql = <<<SQL
SELECT R.NRRESTEMBTPPRAT, IR.CDCONTAINER, C.NMCONTAINER, IR.VRMINCONTAINER,
       CASE WHEN IR.VRMINCONTAINER IS NOT NULL THEN NRORDEM ELSE 999999 END AS NRORDEM,
       C.NRCATEMBALAG
FROM RESTEMBTPPRAT R
     INNER JOIN ITRESTEMBTPPRAT IR ON IR.NRRESTEMBTPPRAT = R.NRRESTEMBTPPRAT
     INNER JOIN CONTAINER C ON C.CDCONTAINER = IR.CDCONTAINER
WHERE R.CDFILIAL = :P_CDFILIAL AND
	   R.CDSERVFILI = :P_CDSERVFILI AND
      R.NRRESTEMBTPPRAT = :P_NRRESTEMBTPPRAT AND
      (((:P_CDCLIENTE IS NULL) AND (R.CDCLIENTE IS NULL)) OR
	      (R.CDCLIENTE = :P_CDCLIENTE AND
	      R.CDDESTFILI = :P_CDDESTFILI)
      )
SQL;
        $params = array(
            'P_CDFILIAL'=>$cdfilial,
            'P_CDSERVFILI'=>$cdservfili,
            'P_CDCLIENTE'=>$cdcliente,
            'P_CDDESTFILI'=>$cddestfili,
            'P_NRRESTEMBTPPRAT'=>$nrrestembtpprat

        );
        try{
            $conn = \Setforms2\Shared\Registry::getEntityManager();
            $conn = $conn->getConnection();
            return $conn-> fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public static function InserseItemImportacao($nrrestricao, $nrrestricao_origem){
        $sql = <<<SQL
INSERT INTO ITRESTEMBTPPRAT
(NRRESTEMBTPPRAT, CDCONTAINER, VRMINCONTAINER, NRORDEM)

SELECT '$nrrestricao', CDCONTAINER, VRMINCONTAINER, NRORDEM
FROM ITRESTEMBTPPRAT
WHERE NRRESTEMBTPPRAT = '$nrrestricao_origem'
SQL;
        try{
            $conn = \Setforms2\Runtime\Connection::getInstance();
            $conn->execute($sql);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public static function DeletaItemRestricaoImport($nrnrestricao){
        $sql = <<<SQL
DELETE FROM ITRESTEMBTPPRAT
WHERE NRRESTEMBTPPRAT = '$nrnrestricao'
SQL;
        try{
            $conn = \Setforms2\Runtime\Connection::getInstance();
            $conn->execute($sql);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public static function BuscaRestricoesPratoEspecifico($cdfilial, $cdservfili, $cdcliente, $cddestfili, $nrseqcnfcard){
        $sql = <<<SQL
SELECT R.NRRESTEMBTPPRAT FROM RESTEMBTPPRAT R
     INNER JOIN ITRESTEMBTPPRAT IR ON IR.NRRESTEMBTPPRAT = R.NRRESTEMBTPPRAT
     INNER JOIN CONTAINER C ON C.CDCONTAINER = IR.CDCONTAINER
WHERE R.CDFILIAL = :P_CDFILIAL AND
	   R.CDSERVFILI = :P_CDSERVFILI AND
      R.NRSEQCNFCARD = :P_NRSEQCNFCARD AND
      (((:P_CDCLIENTE IS NULL) AND (R.CDCLIENTE IS NULL)) OR
	      (R.CDCLIENTE = :P_CDCLIENTE AND
	      R.CDDESTFILI = :P_CDDESTFILI)
      )
SQL;
        $params = array(
            'P_CDFILIAL'=>$cdfilial,
            'P_CDSERVFILI'=>$cdservfili,
            'P_CDCLIENTE'=>$cdcliente,
            'P_CDDESTFILI'=>$cddestfili,
            'P_NRSEQCNFCARD'=>$nrseqcnfcard

        );
        try{
            $conn = \Setforms2\Shared\Registry::getEntityManager();
            $conn = $conn->getConnection();
            return $conn-> fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }

    }

    public static function DeletaItensPorFilial($cdfilial,$cdservfili ){
        $sql = <<<SQL
DELETE FROM ITRESTEMBTPPRAT I
WHERE EXISTS(SELECT 1 FROM RESTEMBTPPRAT R
              WHERE R.NRRESTEMBTPPRAT = I.NRRESTEMBTPPRAT
                AND R.CDFILIAL = '$cdfilial'
                AND R.CDSERVFILI = '$cdservfili')
SQL;
        try{
            $conn = \Setforms2\Runtime\Connection::getInstance();
            $conn->execute($sql);
        } catch (\Exception $e) {
            throw $e;
        }

    }
    public static function DeletaRestricaoPorFilial($cdfilial, $cdservfili){
        $sql = <<<SQL
DELETE FROM RESTEMBTPPRAT
WHERE CDFILIAL = '$cdfilial' AND CDSERVFILI = '$cdservfili'
SQL;
        try{
            $conn = \Setforms2\Runtime\Connection::getInstance();
            $conn->execute($sql);
        } catch (\Exception $e) {
            throw $e;
        }

    }







}