/* Sistemas Integrados TECNISA
   Financeiro

Nome: ATUALIZA_FLUXO_DE_CAIXA.SQL

Descrio:
Atualiza o movimento de fluxo de caixa.

P_CDEMPRESA   - Cdigo da empresa.
P_CDFILIAL    - Cdigo da filial.
P_DTMOVFLUXO  - Data do movimento de fluxo.
P_IDMOVFLUXO  - Identificador do tipo de movimento de fluxo
                "R" Real
                "E" Estimado
P_CDCLASSFINA - Cdigo da classificao financeira.
P_VRENTMFLUXO - Valor de entrada do movimento de fluxo.
P_VRSAIMFLUXO - Valor de sada do movimento de fluxo.

Para aplicar e debugar
-- @H:\SISTEMAS\DBA\SQL\ORACLE\1001_FINSTP_ATUALIZA_FLUXO_DE_CAIXA.SQL;
-- EXECUTE ATUALIZA_FLUXO_DE_CAIXA()
-- SET SERVEROUTPUT ON
-- DBMS_OUTPUT.PUT_LINE('xx');

Criao:
11/05/99 - Ederson

*/

CREATE OR REPLACE
PROCEDURE ATUALIZA_FLUXO_DE_CAIXA
  (P_CDEMPRESA   IN MOVFLUXO.CDEMPRESA%TYPE,
   P_CDFILIAL    IN MOVFLUXO.CDFILIAL%TYPE,
   P_DTMOVFLUXO  IN MOVFLUXO.DTMOVFLUXO%TYPE,
   P_IDMOVFLUXO  IN MOVFLUXO.IDMOVFLUXO%TYPE,
   P_CDCLASSFINA IN MOVFLUXO.CDCLASSFINA%TYPE,
   P_VRENTMFLUXO IN MOVFLUXO.VRENTMFLUXO%TYPE,
   P_VRSAIMFLUXO IN MOVFLUXO.VRSAIMFLUXO%TYPE) IS

   V_EXISTE NUMBER;

BEGIN
   SELECT
      COUNT(*)
   INTO
      V_EXISTE
   FROM
      MOVFLUXO
   WHERE
      (CDEMPRESA   = P_CDEMPRESA)  AND
      (CDFILIAL    = P_CDFILIAL)   AND
      (DTMOVFLUXO  = P_DTMOVFLUXO) AND
      (IDMOVFLUXO  = P_IDMOVFLUXO) AND
      (CDCLASSFINA = P_CDCLASSFINA);

   IF V_EXISTE = 0 THEN
      INSERT INTO MOVFLUXO
         (CDEMPRESA,
          CDFILIAL,
          DTMOVFLUXO,
          IDMOVFLUXO,
          CDCLASSFINA,
          VRENTMFLUXO,
          VRSAIMFLUXO)
      VALUES
         (P_CDEMPRESA,
          P_CDFILIAL,
          P_DTMOVFLUXO,
          P_IDMOVFLUXO,
          P_CDCLASSFINA,
          P_VRENTMFLUXO,
          P_VRSAIMFLUXO);
   ELSE
      UPDATE
         MOVFLUXO
      SET
         VRENTMFLUXO = VRENTMFLUXO + P_VRENTMFLUXO,
         VRSAIMFLUXO = VRSAIMFLUXO + P_VRSAIMFLUXO
      WHERE
         (CDEMPRESA   = P_CDEMPRESA)  AND
         (CDFILIAL    = P_CDFILIAL)   AND
         (DTMOVFLUXO  = P_DTMOVFLUXO) AND
         (IDMOVFLUXO  = P_IDMOVFLUXO) AND
         (CDCLASSFINA = P_CDCLASSFINA);
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ATUALIZA_FLUXO_DE_CAIXA','4.09.066'); END;
/

