IF EXISTS (SELECT
              *
           FROM
              SYSOBJECTS O, SYSUSERS U
           WHERE
              O.NAME = 'ARQDIGITAL_BLOCOE' AND
              TYPE   = 'P' 		   AND
              U.UID  = O.UID               AND
              U.NAME = USER)

DROP PROCEDURE ARQDIGITAL_BLOCOE
GO

CREATE PROCEDURE ARQDIGITAL_BLOCOE 
   @P_CDIMPOSTO   VARCHAR(02),
   @P_CDEMPRESA   VARCHAR(02),
   @P_CDINSCESTA  VARCHAR(14),
   @P_DTINICIAL   DATETIME,
   @P_DTFINAL     DATETIME,
   @P_NRSEQARQMAG VARCHAR(4000), 
   @P_RETURN      NUMERIC  OUTPUT
AS

DECLARE   @V_CONTREGE      NUMERIC;
DECLARE   @V_MOVIMENT      NUMERIC;
DECLARE   @V_CDIMPOSTRIB   VARCHAR(02);
DECLARE   @V_VRTOTIMPOSNF  NUMERIC;
DECLARE   @V_VRTOTENTR     NUMERIC;
DECLARE   @V_VRTOTOUTRCRED NUMERIC;

DECLARE   @V_ARQ_E020      VARCHAR(4000);
DECLARE   @V20_CDFILIAL    VARCHAR(4000);
DECLARE   @V20_NRLANCTONF  VARCHAR(4000);
DECLARE   @V_ARQ_E530      VARCHAR(4000);
DECLARE   @V_ARQ_E025      VARCHAR(4000);
DECLARE   @C_ARQ_E050      VARCHAR(4000);
DECLARE   @C050_NRLANCTONF VARCHAR(4000);
DECLARE   @C050_CDFILIAL   VARCHAR(4000);
DECLARE   @C_ARQ_E055      VARCHAR(4000);
DECLARE   @C_ARQ_E085      VARCHAR(4000);
DECLARE   @C080_CDFILIAL   VARCHAR(4000);
DECLARE   @C080_NRLANCTONF VARCHAR(4000);
DECLARE   @C_ARQ_E080      VARCHAR(4000);
DECLARE   @C100_CDFILIAL   VARCHAR(4000);
DECLARE   @C100_NRLANCTONF VARCHAR(4000);
DECLARE   @C_ARQ_E100      VARCHAR(4000);
DECLARE   @C120_CDFILIAL   VARCHAR(4000);
DECLARE   @C120_NRLANCTONF VARCHAR(4000);
DECLARE   @C_ARQ_E120      VARCHAR(4000);
DECLARE   @C_ARQ_E105      VARCHAR(4000);
DECLARE   @C_ARQ_E300      VARCHAR(4000);
DECLARE   @C300_DTINICIAL  VARCHAR(8);
DECLARE   @C300_DTFINAL    VARCHAR(8);
DECLARE   @C_ARQ_E310      VARCHAR(4000);
DECLARE   @C_ARQ_E320      VARCHAR(4000);
DECLARE   @C_ARQ_E330      VARCHAR(4000);
DECLARE   @C_ARQ_E340      VARCHAR(4000);
DECLARE   @C_ARQ_E350      VARCHAR(4000);
DECLARE   @C_ARQ_E360      VARCHAR(4000);
DECLARE   @C_ARQ_E500      VARCHAR(4000);
DECLARE   @C_ARQ_E510      VARCHAR(4000);
DECLARE   @C_ARQ_E530      VARCHAR(4000);
DECLARE   @C500_DTINICIAL  VARCHAR(4000);
DECLARE   @C500_DTFINAL    VARCHAR(4000);
DECLARE   @C510_IMPOSTRIB  VARCHAR(4000);
DECLARE   @C300DTINICIAL   VARCHAR(4000);

BEGIN

   SET @V_CONTREGE = 0; 
   SET @V_MOVIMENT = 0;
   DECLARE C_REGE020 CURSOR FOR (SELECT('|E020'                                                                                                                                                   + '|' + 
                                         ISNULL(N.CAMPO2, '')                                                                                                                                     + '|' +
                                         ISNULL(N.CAMPO3, '')                                                                                                                                     + '|' +
                                         ISNULL(N.IDORIG, '')                                                                                                                                     + '|' +
                                         ISNULL(N.CDMODDOCFISC, '')                                                                                                                               + '|' +
                                         ISNULL(N.IDSTATUS, '')                                                                                                                                   + '|' +
                                         ISNULL(N.CDSERIE, '')                                                                                                                                    + '|' +
                                         ISNULL(N.NRNOTAFISC, '')                                                                                                                                 + '|' +
                                         ISNULL(DTEMISSAO, '')                                                                                                                                    + '|' +
                                         ISNULL(N.NRLANCTBDOC, '')                                                                                                                                + '|' +
                                         ISNULL(N.DTENTRSAID, '')                                                                                                                                 + '|' +
                                         ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),N.VRCONTABILNF))), '.', ','),'0,00')                                                          + '|' +
                                         ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),N.VRBASECALCNF))), '.', ','),'0,00')                                                          + '|' +
                                         ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),N.VRIMPOSTONF))), '.', ','),'0,00')                                                           + '|' +
    /* verificar quinto campo */         ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),TEKNISA.VALOR_IMPOSTO_NF(N.CDFILIAL,N.NRLANCTONF,N.CDIMPOSTRIB,'I', null)))),'.',','),'0,00') + '|' +
                                         '0,00'                                                                                                                                                   + '|' +
                                         '00'                                                                                                                                                     + '|' +
                                         ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),N.VRISENTRIB))), '.', ','),'0,00')                                                            + '|' +
                                         ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),N.VROUTRCRED))), '.', ','),'0,00')                                                            + '|' +
                                         ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),TEKNISA.VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, '10', 'B', '1')))), '.', ','),'0,00')      + '|' +
                                         ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),TEKNISA.VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, '10', 'I', '1')))), '.', ','),'0,00')      + '|' +
                                         ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),TEKNISA.VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, '10', 'C', '2')))), '.', ','),'0,00')      + '|' +
                                         ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),TEKNISA.VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, '10', 'C', '3')))), '.', ','),'0,00')      + '|' +
                                         ''                                                                                                                               + '|'  ) AS ARQ_E020,
                                         N.CDFILIAL, N.NRLANCTONF
                                 FROM(SELECT '1' AS CAMPO2,
                                             '0' AS CAMPO3,
                                             CASE N.IDORIGDESTNF WHEN 'F' THEN N.CDFORNECED ELSE  CASE N.IDORIGDESTNF WHEN 'C' THEN N.CDCLIENTE ELSE CASE N.IDENTRSAIDOP WHEN 'E' THEN N.CDFILIEMIT ELSE N.CDFILIRECE END END END AS IDORIG,
                                             N.CDMODDOCFISC,                                    
        				     CASE N.IDSTATUS WHEN 'C' THEN '02' ELSE '00' END AS IDSTATUS,
                                             N.CDSERIE,
                                             N.NRNOTAFISC,
                                             N.CDFILIAL,
                                             N.NRLANCTONF,
                                             REPLACE(CONVERT(VARCHAR, N.DTEMISSAO,103), '/', '') AS DTEMISSAO,
                                             N.NRLANCTBDOC,
                                             REPLACE(CONVERT(VARCHAR,N.DTENTRSAID,103), '/', '') AS DTENTRSAID,
                                             P.CDIMPOSTRIB,
                                             SUM(CONVERT(NUMERIC(12,2), I.VRCONTABILNF)) AS VRCONTABILNF,
                                             SUM(CASE I.CDFISCALNF WHEN '1' THEN CONVERT(NUMERIC(12,2),I.VRBASECALCNF)ELSE 0 END) AS VRBASECALCNF,
                                             SUM(CASE I.CDFISCALNF WHEN '1' THEN CONVERT(NUMERIC(12,2),I.VRIMPOSTONF) ELSE 0 END) AS VRIMPOSTONF,
                                             SUM(CASE I.CDFISCALNF WHEN '3' THEN CONVERT(NUMERIC(12,2),I.VRCONTABILNF)ELSE 0 END) AS VROUTRCRED,
                                             SUM(CASE I.CDFISCALNF WHEN '2' THEN I.VRCONTABILNF                       ELSE 0 END) AS VRISENTRIB
                                     FROM MAPAAPURAC M, NOTAFISCAL N, IMPOSTONF I, IMPOSTO P
                                     WHERE M.CDEMPRESA       = @P_CDEMPRESA                                  AND
                                           M.CDINSCESTA      = @P_CDINSCESTA                                 AND
                                           M.DTINIPERIODO    = @P_DTINICIAL                                  AND
                                           M.DTFIMPERIODO    = @P_DTFINAL                                    AND
                                           M.CDIMPOSTO       = @P_CDIMPOSTO                                  AND
                                           I.NRSEQUMAPAPU    = M.NRSEQUMAPAPU                                AND
                                           I.CDIMPOSTO       = @P_CDIMPOSTO                                  AND
                                           I.CDIMPOSTO       = P.CDIMPOSTO                                   AND
                                           ISNULL(I.IDIMPOSTONF, '1') <> '3'                                 AND
                                           N.CDFILIAL        = I.CDFILIAL                                    AND
                                           N.IDENTRSAIDOP    = 'S'                                           AND
                                           N.NRLANCTONF      = I.NRLANCTONF                                  AND
                                           ((N.IDSTATUS = 'A')  OR (N.IDSTATUS = 'E'))                       AND
                                           ISNULL(N.CDSERIE,'') <> 'ECF'                                     AND
                                           ((N.CDMODDOCFISC = '01') OR (N.CDMODDOCFISC = '04') OR (N.CDMODDOCFISC = '55'))
                                     GROUP BY CASE N.IDENTRSAIDOP WHEN 'E' THEN '0' ELSE '1' END,
                                           CASE N.IDORIGDESTNF    WHEN 'F' THEN N.CDFORNECED ELSE  CASE N.IDORIGDESTNF WHEN 'C' THEN N.CDCLIENTE ELSE CASE N.IDENTRSAIDOP WHEN 'E' THEN N.CDFILIEMIT ELSE N.CDFILIRECE END END END,
                                           N.CDMODDOCFISC, CASE N.IDSTATUS WHEN 'C' THEN '02' ELSE '00' END, N.CDSERIE, N.NRNOTAFISC, REPLACE(CONVERT(VARCHAR,N.DTEMISSAO,103), '/', ''),
                                           N.NRLANCTBDOC, REPLACE(CONVERT(VARCHAR,N.DTENTRSAID,103), '/', ''), N.CDFILIAL, N.NRLANCTONF,P.CDIMPOSTRIB
                                   UNION ALL
                                   SELECT '0' AS CAMPO2,
                                          '1' AS CAMPO3,
                                          CASE N.IDORIGDESTNF WHEN 'F' THEN N.CDFORNECED ELSE CASE N.IDORIGDESTNF WHEN 'C' THEN N.CDCLIENTE ELSE CASE N.IDENTRSAIDOP WHEN 'E' THEN N.CDFILIEMIT ELSE N.CDFILIRECE END END END  AS IDORIG,
                                          N.CDMODDOCFISC,
                                          CASE N.IDSTATUS     WHEN 'C' THEN '02'         ELSE '00' END AS IDSTATUS,
                                          N.CDSERIE,
                                          N.NRNOTAFISC,
                                          N.CDFILIAL,
                                          N.NRLANCTONF,
                                          REPLACE(CONVERT(VARCHAR,N.DTEMISSAO,103), '/', '') AS DTEMISSAO,
                                          N.NRLANCTBDOC,
                                          REPLACE(CONVERT(VARCHAR,N.DTENTRSAID,103), '/', '') AS DTENTRSAID,
                                          P.CDIMPOSTRIB,
                                          SUM(CONVERT(NUMERIC(12,2),I.VRCONTABILNF)) AS VRCONTABILNF,
                                          SUM(CASE I.CDFISCALNF  WHEN '1' THEN CONVERT(NUMERIC(12,2),I.VRBASECALCNF)  ELSE 0 END) AS VRBASECALCNF,
                                          SUM(CASE I.CDFISCALNF  WHEN '1' THEN CONVERT(NUMERIC(12,2),I.VRIMPOSTONF)   ELSE 0 END)  AS VRIMPOSTONF,
                                          SUM(CASE I.CDFISCALNF  WHEN '3' THEN CONVERT(NUMERIC(12,2),I.VRCONTABILNF)  ELSE 0 END)   AS VROUTRCRED,
                                          SUM(CASE I.CDFISCALNF  WHEN '2' THEN I.VRCONTABILNF           ELSE 0 END) AS VRISENTRIB
                                   FROM MAPAAPURAC M, NOTAFISCAL N, IMPOSTONF I, IMPOSTO P
                                   WHERE M.CDEMPRESA       = @P_CDEMPRESA                                 AND
                                         M.CDINSCESTA      = @P_CDINSCESTA                                AND
                                         M.DTINIPERIODO    = @P_DTINICIAL                                 AND
                                         M.DTFIMPERIODO    = @P_DTFINAL                                   AND
                                         M.CDIMPOSTO       = @P_CDIMPOSTO                                 AND
                                         I.NRSEQUMAPAPU    = M.NRSEQUMAPAPU                               AND
                                         I.CDIMPOSTO       = @P_CDIMPOSTO                                 AND
                                         I.CDIMPOSTO       = P.CDIMPOSTO                                  AND
                                         ISNULL(I.IDIMPOSTONF, '1') <> '3'                                AND
                                         N.IDENTRSAIDOP    = 'E'                                          AND
                                         N.CDFILIAL        = I.CDFILIAL                                   AND
                                         N.NRLANCTONF      = I.NRLANCTONF                                 AND
                                         ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E'))                       AND
                                         ISNULL(N.CDSERIE,' ')         <> 'ECF'                           AND
                                         ((N.CDMODDOCFISC = '01') OR (N.CDMODDOCFISC = '04') OR (N.CDMODDOCFISC = '55'))
                                   GROUP BY CASE N.IDENTRSAIDOP WHEN 'E' THEN '0' ELSE '1' END,
                                            CASE N.IDORIGDESTNF WHEN 'F' THEN  N.CDFORNECED ELSE CASE N.IDORIGDESTNF WHEN 'C' THEN N.CDCLIENTE ELSE CASE N.IDENTRSAIDOP WHEN 'E' THEN N.CDFILIEMIT ELSE N.CDFILIRECE END END END,
                                            N.CDMODDOCFISC, CASE N.IDSTATUS WHEN 'C' THEN '02' ELSE '00' END, N.CDSERIE, N.NRNOTAFISC, REPLACE(CONVERT(VARCHAR,N.DTEMISSAO,103), '/', ''),
                                            N.NRLANCTBDOC, REPLACE(CONVERT(VARCHAR,N.DTENTRSAID,103),'/', ''), N.CDFILIAL, N.NRLANCTONF,P.CDIMPOSTRIB)  N ) 
    OPEN C_REGE020;

    FETCH NEXT FROM C_REGE020 INTO @V_ARQ_E020, @V20_CDFILIAL, @V20_NRLANCTONF;

    WHILE (@@FETCH_STATUS = 0) BEGIN

        INSERT INTO ARQMAGNETICO
            (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
        VALUES
            ('30'+RIGHT(REPLICATE('0',8)+RTRIM(@V_CONTREGE), 8), @V_ARQ_E020, @P_NRSEQARQMAG);
        SET @V_CONTREGE = ISNULL(@V_CONTREGE,0) + 1;

        SELECT @V_CDIMPOSTRIB = CDIMPOSTRIB
        FROM IMPOSTO
        WHERE CDIMPOSTRIB IS NOT NULL AND
              CDIMPOSTO = @P_CDIMPOSTO;
  
        DECLARE C_REGE025 CURSOR FOR (SELECT('|E025'                                                                             + '|' +
                                             ISNULL(N.CDFISCOPERNF, '')                                                                                  + '|' +
                                             ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),N.VRCONTABILNF))), '.', ','),'0,00') + '|' +
                                             ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),N.VRBASECALCNF))), '.', ','),'0,00') + '|' +
                                             ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),N.VRALIQNF))), '.', ','),'0,00')     + '|' +
                                             ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),N.VRIMPOSTONF))), '.', ','),'0,00')  + '|' +
                                             ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),TEKNISA.VALOR_IMPOSTO_NF(@V20_CDFILIAL, @V20_NRLANCTONF, @V_CDIMPOSTRIB, 'I', '1')))), '.', ','),'0,00')  + '|' +
                                             '0,00'                                                                                          + '|' +
                                             ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),N.VRISENTRIB))), '.', ','),'0,00')   + '|' +
                                             ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),N.VROUTRCRED))), '.', ','),'0,00')   + '|' +
                                             CASE MENALIQ.VRALIQNF WHEN N.VRALIQNF THEN ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),TEKNISA.VALOR_IMPOSTO_NF(@V20_CDFILIAL, @V20_NRLANCTONF, '10', 'B', '1')))), '.', ','),'0,00') ELSE '0,00' END  + '|' +
                                             CASE MENALIQ.VRALIQNF WHEN N.VRALIQNF THEN ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),TEKNISA.VALOR_IMPOSTO_NF(@V20_CDFILIAL, @V20_NRLANCTONF, '10', 'I', '1')))), '.', ','),'0,00') ELSE '0,00' END  + '|' +
                                             CASE MENALIQ.VRALIQNF WHEN N.VRALIQNF THEN ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),TEKNISA.VALOR_IMPOSTO_NF(@V20_CDFILIAL, @V20_NRLANCTONF, '10', 'C', '2')))), '.', ','),'0,00') ELSE '0,00' END  + '|' +
                                             CASE MENALIQ.VRALIQNF WHEN N.VRALIQNF THEN ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),TEKNISA.VALOR_IMPOSTO_NF(@V20_CDFILIAL, @V20_NRLANCTONF, '10', 'C', '3')))), '.', ','),'0,00') ELSE '0,00' END  + '|'  ) AS ARQ_E025
                                    FROM (SELECT I.CDFISCOPERNF,
                                                 I.VRALIQNF,
                                                 ISNULL(SUM(CONVERT(NUMERIC(12,2), I.VRCONTABILNF)),0) AS VRCONTABILNF,
                                                 ISNULL(SUM(CASE I.CDFISCALNF WHEN '1' THEN CONVERT(NUMERIC(12,2),I.VRBASECALCNF) ELSE 0 END),0) AS VRBASECALCNF,
                                                 ISNULL(SUM(CASE I.CDFISCALNF WHEN '1' THEN CONVERT(NUMERIC(12,2),I.VRIMPOSTONF)  ELSE 0 END),0) AS VRIMPOSTONF,
                                                 ISNULL(SUM(CASE I.CDFISCALNF WHEN '3' THEN CONVERT(NUMERIC(12,2),I.VRCONTABILNF) ELSE 0 END),0) AS VROUTRCRED,
                                                 ISNULL(SUM(CASE I.CDFISCALNF WHEN '2' THEN I.VRCONTABILNF ELSE '0' END),0) AS VRISENTRIB
 
					  FROM IMPOSTONF I
                                          WHERE I.CDFILIAL       = @V20_CDFILIAL      AND
                                                I.NRLANCTONF     = @V20_NRLANCTONF    AND
                                                I.NRSEQUMAPAPU   IS NOT NULL          AND
                                                I.CDIMPOSTO      = @P_CDIMPOSTO       AND
                                                ISNULL(I.IDIMPOSTONF, '1') <> '3'
                                          GROUP BY I.CDFISCOPERNF, I.VRALIQNF) N,
                                         (SELECT MIN(I.VRALIQNF) AS VRALIQNF
                                          FROM IMPOSTONF I
                                          WHERE I.CDFILIAL   = @V20_CDFILIAL          AND
                                                I.NRLANCTONF = @V20_NRLANCTONF        AND
                                                I.CDIMPOSTO  = @P_CDIMPOSTO         ) MENALIQ )
        OPEN C_REGE025;

        FETCH NEXT FROM C_REGE025 INTO @V_ARQ_E025;

        WHILE (@@FETCH_STATUS = 0) BEGIN

          INSERT INTO ARQMAGNETICO
            (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
          VALUES
             ('30'+RIGHT(REPLICATE('0',8)+RTRIM(@V_CONTREGE), 8), @V_ARQ_E025 , @P_NRSEQARQMAG);
             SET @V_CONTREGE = ISNULL(@V_CONTREGE,0) + 1;
         FETCH NEXT FROM C_REGE025 INTO @V_ARQ_E025;
       END;
       CLOSE C_REGE025;
       DEALLOCATE C_REGE025;

       FETCH NEXT FROM C_REGE020 INTO @V_ARQ_E020, @V20_CDFILIAL, @V20_NRLANCTONF;

   END;
   CLOSE C_REGE020;
   DEALLOCATE C_REGE020;

   DECLARE C_REGE050 CURSOR FOR (SELECT ('|E050'                                                                             + '|' +
                                         ISNULL(NF.CDMODDOCFISC, '')                                                                                + '|' +
                                         ISNULL(NF.CDSERIE, '')                                                                                      + '|' +
                                         ''                                                                                              + '|' +
                                         ISNULL(NF.NRNOTAFISC, '')                                                                                   + '|' +
                                         ISNULL(NF.NRNOTAFISC, '')                                                                                   + '|' +
                                         ISNULL(REPLACE(CONVERT(VARCHAR,NF.DTEMISSAO,103), '/', ''), '')                                             + '|' +
                                         ''                                                                                              + '|' +
                                         ''                                                                                              + '|' +
                                         ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),NF.VRCONTABILNF))),'.', ','),'0,00') + '|' +
                                         ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),NF.VRBASECALCNF))),'.', ','),'0,00') + '|' +
                                         ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),NF.VRIMPOSTONF))), '.', ','),'0,00') + '|' +
                                         ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),NF.VRISENTAS))),   '.', ','),'0,00') + '|' +
                                         ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),NF.VROUTRCRED))),  '.', ','),'0,00') + '|' +
                                         ''                                                                                              + '|'  ) AS ARQ_E050,
                                         NF.NRLANCTONF, NF.CDFILIAL
                               FROM (SELECT I.CDFILIAL, I.NRLANCTONF, N.CDMODDOCFISC, N.CDSERIE,N.NRNOTAFISC,
                                            N.DTEMISSAO, N.NRLANCTBDOC,
                                            SUM(I.VRCONTABILNF) AS VRCONTABILNF,
                                            SUM(I.VRBASECALCNF) AS VRBASECALCNF,
                                            SUM(I.VRIMPOSTONF)  AS VRIMPOSTONF,
                                            SUM(CASE I.CDFISCALNF WHEN '3' THEN CONVERT(NUMERIC(12,2), I.VRCONTABILNF) ELSE  0 END) AS VROUTRCRED,
                                            SUM(CASE CDFISCALNF   WHEN '2' THEN VRCONTABILNF           		       ELSE  0 END) AS VRISENTAS
				     FROM MAPAAPURAC M, NOTAFISCAL N, IMPOSTONF I
                                     WHERE M.CDEMPRESA       = @P_CDEMPRESA                  AND
                                           M.CDINSCESTA      = @P_CDINSCESTA                 AND
                                           M.DTINIPERIODO    = @P_DTINICIAL                  AND
                                           M.DTFIMPERIODO    = @P_DTFINAL                    AND
                                           M.CDIMPOSTO       = @P_CDIMPOSTO                  AND
                                           I.NRSEQUMAPAPU    = M.NRSEQUMAPAPU                AND
                                           I.CDIMPOSTO       = @P_CDIMPOSTO                  AND
                                           N.CDFILIAL        = I.CDFILIAL                    AND
                                           N.CDMODDOCFISC    = '02'                          AND
                                           ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E'))        AND
                                           N.CDSERIE         <> 'ECF'                        AND
                                           N.NRLANCTONF      = I.NRLANCTONF
                                     GROUP BY I.CDFILIAL, I.NRLANCTONF, N.CDMODDOCFISC, N.CDSERIE,
                                              N.DTEMISSAO, N.NRLANCTBDOC, N.NRNOTAFISC) NF )
     OPEN C_REGE050;

     FETCH NEXT FROM C_REGE050 INTO @C_ARQ_E050, @C050_NRLANCTONF, @C050_CDFILIAL;

     WHILE (@@FETCH_STATUS = 0) BEGIN
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        ('31'+RIGHT(REPLICATE('0',8)+RTRIM(@V_CONTREGE), 8),@C_ARQ_E050, @P_NRSEQARQMAG);
      SET @V_CONTREGE =  ISNULL(@V_CONTREGE,0) + 1;

      DECLARE C_REGE055 CURSOR FOR (SELECT  ('|E055'         + '|' +
                                             ISNULL(NF.CDFISCOPERNF, '') + '|' +
                                             ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),NF.VRCONTABILNF))),'.', ','),'0,00') + '|' +
                                             ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),NF.VRBASECALCNF))),'.', ','),'0,00') + '|' +
                                             ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),NF.VRALIQNF))),    '.', ','),'0,00') + '|' +
                                             ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),NF.VRIMPOSTONF))), '.', ','),'0,00') + '|' +
                                             ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),NF.VRISENTRIB))),  '.', ','),'0,00') + '|' +
                                             ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),NF.VROUTRCRED))),  '.', ','),'0,00') + '|' ) AS ARQ_E055

                                    FROM(SELECT I.CDIMPOSTO, I.CDFISCOPERNF,
                                                SUM(I.VRCONTABILNF) AS VRCONTABILNF,
                                                SUM(I.VRBASECALCNF) AS VRBASECALCNF,
                                                I.VRALIQNF          AS VRALIQNF,
                                                SUM(I.VRIMPOSTONF)  AS VRIMPOSTONF,
                                                SUM(CASE I.CDFISCALNF WHEN '3' THEN CONVERT(NUMERIC(12,2),I.VRCONTABILNF) ELSE 0 END)   AS VROUTRCRED,
                                                SUM(CASE I.CDFISCALNF WHEN '2' THEN I.VRCONTABILNF ELSE '0' END) AS VRISENTRIB
                                         FROM IMPOSTONF I
                                         WHERE @C050_CDFILIAL    = I.CDFILIAL       AND
                                               @C050_NRLANCTONF  = I.NRLANCTONF     AND
                                               ISNULL(I.IDIMPOSTONF, '1') <> '3'           AND
                                               I.CDIMPOSTO           = @P_CDIMPOSTO
                                         GROUP BY I.CDIMPOSTO, I.CDFISCOPERNF, I.VRALIQNF ) NF   )
     OPEN C_REGE055;

     FETCH NEXT FROM C_REGE055 INTO @C_ARQ_E055;

     WHILE (@@FETCH_STATUS = 0) BEGIN 

         INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           ('31'+RIGHT(REPLICATE('0',8)+RTRIM(@V_CONTREGE), 8), @C_ARQ_E055, @P_NRSEQARQMAG);
         SET @V_CONTREGE =  ISNULL(@V_CONTREGE,0) + 1;
      
         FETCH NEXT FROM C_REGE055 INTO @C_ARQ_E055;
      END;
      CLOSE C_REGE055;
      DEALLOCATE C_REGE055;

     FETCH NEXT FROM C_REGE050 INTO @C_ARQ_E050, @C050_NRLANCTONF, @C050_CDFILIAL;

   END;
   CLOSE C_REGE050;
   DEALLOCATE C_REGE050;


   /* REGISTRO E080 */
   DECLARE C_REGE080 CURSOR FOR (SELECT /* 01 */ ('|E080'         + '|' +
                                        /* 02 */  '0'             + '|' +
                                        /* 03 */  ISNULL(N.NRNOTAFISC, '')    + '|' +
                                        /* 04 */  ISNULL(N.NRLANCTBDOC, '')   + '|' +
                                        /* 05 */  ISNULL(N.DTENTRSAID, '')    + '|' +
                                        /* 06 */  ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),N.VRCONTABILNF))), '.', ','),'0,00')  + '|' +
                                        /* 07 */  '0'  + '|' +
                                        /* 08 */  '0'  + '|' +
                                        /* 09 */  '0'  + '|' +
                                        /* 10 */  '0'  + '|' +
                                        /* 11 */  '0'  + '|' +
                                        /* 12 */  '0'  + '|' +
                                        /* 13 */  '0'  + '|' +
                                        /* 14 */  '0'  + '|' +
                                        /* 15 */  '0'  + '|' +
                                        /* 16 */  '0'  + '|' +
                                        /* 17 */  ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),N.VRCONTABILNF))), '.', ','),'0,00')  + '|' +
                                        /* 18 */  ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),N.VRBASECALCNF))), '.', ','),'0,00')  + '|' +
                                        /* 19 */  ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),N.VRIMPOSTONF))), '.', ','),'0,00')  + '|' +
                                        /* 20 */  ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),N.VRISENTRIB))), '.', ','),'0,00')  + '|' +
                                        /* 21 */  '0'    + '|' +
                                        /* 22 */  ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),N.VROUTRCRED))), '.', ','),'0,00')  + '|' +
                                        /* 23 */  '0'  + '|'  ) AS ARQ_E080, N.CDFILIAL, N.NRLANCTONF
                                 FROM(SELECT N.CDSERIE,
                                             N.NRNOTAFISC,
                                             N.CDFILIAL,
                                             N.NRLANCTONF,
                                             N.NRLANCTBDOC,
                                             REPLACE(CONVERT(VARCHAR,N.DTENTRSAID,103), '/', '') AS DTENTRSAID,
                                             SUM(CONVERT(NUMERIC(12,2), N.VRNOTAFISC)) AS VRNOTAFISC,
                                             SUM(CONVERT(NUMERIC(12,2),I.VRCONTABILNF)) AS VRCONTABILNF,
                                             SUM(CASE I.CDFISCALNF WHEN '1' THEN CONVERT(NUMERIC(12,2),I.VRBASECALCNF) ELSE 0 END) AS VRBASECALCNF,
                                             SUM(CASE I.CDFISCALNF WHEN '1' THEN CONVERT(NUMERIC(12,2),I.VRIMPOSTONF)  ELSE 0 END)  AS VRIMPOSTONF,
                                             SUM(CASE I.CDFISCALNF WHEN '3' THEN CONVERT(NUMERIC(12,2),I.VRCONTABILNF) ELSE 0 END) AS VROUTRCRED,
                                             SUM(CASE I.CDFISCALNF WHEN '2' THEN I.VRCONTABILNF ELSE 0 END) AS VRISENTRIB
                                      FROM MAPAAPURAC M, NOTAFISCAL N, IMPOSTONF I
                                      WHERE M.CDEMPRESA       = @P_CDEMPRESA                                 AND
                                            M.CDINSCESTA      = @P_CDINSCESTA                                AND
                                            M.DTINIPERIODO    = @P_DTINICIAL                                 AND
                                            M.DTFIMPERIODO    = @P_DTFINAL                                   AND
                                            M.CDIMPOSTO       = @P_CDIMPOSTO                                 AND
                                            I.NRSEQUMAPAPU    = M.NRSEQUMAPAPU                               AND
                                            I.CDIMPOSTO       = @P_CDIMPOSTO                                 AND
                                            ISNULL(I.IDIMPOSTONF, '1') <> '3'                                AND
                                            N.CDFILIAL        = I.CDFILIAL                                   AND
                                            N.NRLANCTONF      = I.NRLANCTONF                                 AND
                                            ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E'))                       AND
                                            N.CDSERIE         = 'ECF'                                        AND
                                            N.IDENTRSAIDOP    = 'S'
                                      GROUP BY N.CDSERIE, N.NRNOTAFISC, N.CDFILIAL, N.NRLANCTONF, N.NRLANCTBDOC,
                                               REPLACE(CONVERT(VARCHAR,N.DTENTRSAID,103), '/', ''))  N )
     OPEN C_REGE080;

     FETCH NEXT FROM C_REGE080 INTO @C_ARQ_E080, @C080_CDFILIAL, @C080_NRLANCTONF;

     WHILE (@@FETCH_STATUS = 0) BEGIN

         INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           ('32'+RIGHT(REPLICATE('0',8)+RTRIM(@V_CONTREGE), 8), @C_ARQ_E080, @P_NRSEQARQMAG);
         SET @V_CONTREGE =  ISNULL(@V_CONTREGE,0) + 1;

 
      /* REGISTRO E085 */
      DECLARE C_REGE085 CURSOR FOR (SELECT(/* 01 */     '|E085' + '|' +
                                           /* 02 */      '0'    + '|' +
                                           /* 03 */      '0'    + '|' +
                                           /* 04 */      '0'    + '|' +
                                           /* 05 */      '0'    + '|' +
                                           /* 06 */      '0'    + '|' +
                                           /* 07 */      '0'    + '|' +
                                           /* 08 */      '0'    + '|' +
                                           /* 09 */      ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR, CONVERT(NUMERIC(12,2),N.VRCONTABILNF))), '.', ','),'0,00') + '|' +
                                           /* 10 */      ISNULL(N.CDFISCOPERNF, '')      										  + '|' +
                                           /* 11 */      ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR, CONVERT(NUMERIC(12,2),N.VRBASECALCNF))), '.', ','),'0,00') + '|' +
                                           /* 12 */      ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR, CONVERT(NUMERIC(12,2),N.VRALIQNF))), '.', ','),'0,00')     + '|' +
                                           /* 13 */      ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR, CONVERT(NUMERIC(12,2),N.VRIMPOSTONF))), '.', ','),'0,00')  + '|' +
                                           /* 14 */      ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR, CONVERT(NUMERIC(12,2),N.VRISENTRIB))), '.', ','),'0,00')   + '|' +
                                           /* 15 */      '0'  												  + '|' +
                                           /* 16 */      ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR, CONVERT(NUMERIC(12,2),N.VROUTRCRED))), '.', ','),'0,00')   + '|'  ) AS ARQ_E085
                                    FROM(SELECT I.CDFISCOPERNF,
                                                I.VRALIQNF,
                                                ISNULL(SUM(CONVERT(NUMERIC(12,2),I.VRCONTABILNF)),0) AS VRCONTABILNF,
                                                ISNULL(SUM(CASE I.CDFISCALNF WHEN '1' THEN CONVERT(NUMERIC(12,2),I.VRBASECALCNF) ELSE 0 END),0) AS VRBASECALCNF,
                                                ISNULL(SUM(CASE I.CDFISCALNF WHEN '1' THEN CONVERT(NUMERIC(12,2),I.VRIMPOSTONF)  ELSE 0 END),0)  AS VRIMPOSTONF,
                                                ISNULL(SUM(CASE I.CDFISCALNF WHEN '3' THEN CONVERT(NUMERIC(12,2),I.VRCONTABILNF) ELSE 0 END),0) AS VROUTRCRED,
                                                ISNULL(SUM(CASE I.CDFISCALNF WHEN '2' THEN I.VRCONTABILNF ELSE 0 END),0) AS VRISENTRIB
                                         FROM IMPOSTONF I
                                         WHERE I.CDFILIAL       = @C080_CDFILIAL    AND
                                               I.NRLANCTONF     = @C080_NRLANCTONF  AND
                                               I.NRSEQUMAPAPU   IS NOT NULL         AND
                                               I.CDIMPOSTO      = @P_CDIMPOSTO      AND
                                               ISNULL(I.IDIMPOSTONF, '1') <> '3'
                                         GROUP BY I.CDFISCOPERNF, I.VRALIQNF) N)

     OPEN C_REGE085;

     FETCH NEXT FROM C_REGE085 INTO @C_ARQ_E085;

     WHILE (@@FETCH_STATUS = 0) BEGIN

         INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           ('32'+RIGHT(REPLICATE('0',8)+RTRIM(@V_CONTREGE), 8), @C_ARQ_E085, @P_NRSEQARQMAG);
         SET @V_CONTREGE =  ISNULL(@V_CONTREGE,0) + 1;
      
         FETCH NEXT FROM C_REGE085 INTO @C_ARQ_E085;

      END;
      CLOSE C_REGE085;
      DEALLOCATE C_REGE085;

      FETCH NEXT FROM C_REGE080 INTO @C_ARQ_E080, @C080_CDFILIAL, @C080_NRLANCTONF ;

   END;
   CLOSE C_REGE080;
   DEALLOCATE C_REGE080;  

 /* REGISTRO E100 */
   DECLARE C_REGE100 CURSOR FOR (SELECT(/* 01 */   '|E100'                    + '|' +
                                        /* 02 */   ISNULL(N.IDENTRSAIDOP, '')             + '|' +
                                        /* 03 */   '1'                        + '|' +
                                        /* 04 */   ISNULL(N.IDORIG, '')                   + '|' +
                                        /* 05 */   ISNULL(N.CDMODDOCFISC, '')             + '|' +
                                        /* 06 */   ISNULL(N.IDSTATUS, '')                 + '|' +
                                        /* 07 */   ISNULL(N.CDSERIE, '')                  + '|' +
                                        /* 08 */   ''                         + '|' +
                                        /* 09 */   '99'                       + '|' +
                                        /* 10 */   ISNULL(N.NRNOTAFISC, '')               + '|' +
                                        /* 11 */   ISNULL(N.DTEMISSAO, '')                + '|' +
                                        /* 12 */   ISNULL(N.NRLANCTBDOC, '')              + '|' +
                                        /* 13 */   ISNULL(DTENTRSAID, '')                 + '|' +
                                        /* 14 */   '1'                        + '|' +
                                        /* 15 */   CONVERT(VARCHAR, CANC.QTNFCANCEL)            + '|' +
                                        /* 16 */   ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR, CONVERT(NUMERIC(12,2),N.VRCONTABILNF))), '.', ','),'0,00') + '|' +
                                        /* 17 */   ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR, CONVERT(NUMERIC(12,2),N.VRBASECALCNF))), '.', ','),'0,00') + '|' +
                                        /* 18 */   ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR, CONVERT(NUMERIC(12,2),N.VRIMPOSTONF))),  '.', ','),'0,00') + '|' +
                                        /* 19 */   ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR, CONVERT(NUMERIC(12,2),N.VRISENTRIB))),   '.', ','),'0,00') + '|' +
                                        /* 20 */   ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR, CONVERT(NUMERIC(12,2),N.VROUTRCRED))),   '.', ','),'0,00') + '|' +
                                        /* 21 */   ''                                                                                      + '|'  ) AS ARQ_E100,
                                        N.CDFILIAL, N.NRLANCTONF
                                 FROM(SELECT N.CDFILIAL, N.NRLANCTONF,
                                             CASE N.IDENTRSAIDOP WHEN 'E' THEN '0' ELSE '1'END  AS IDENTRSAIDOP,
                                             CASE N.IDORIGDESTNF WHEN 'F' THEN  N.CDFORNECED END AS IDORIG,
                                             N.CDMODDOCFISC,
                                             CASE N.IDSTATUS WHEN 'C' THEN '02' ELSE '00' END AS IDSTATUS,
                                             ISNULL(N.CDSERIE, N.CDSERIEENTR) AS CDSERIE,
                                             N.NRNOTAFISC,
                                             REPLACE(CONVERT(VARCHAR,N.DTEMISSAO,103), '/', '') AS DTEMISSAO,
                                             N.NRLANCTBDOC,
                                             REPLACE(CONVERT(VARCHAR,N.DTENTRSAID,103), '/', '') AS DTENTRSAID,
                                             SUM(CONVERT(NUMERIC(12,2),I.VRCONTABILNF)) AS VRCONTABILNF,
                                             SUM(CASE I.CDFISCALNF WHEN '1' THEN CONVERT(NUMERIC(12,2),I.VRBASECALCNF) ELSE 0 END) AS VRBASECALCNF,
                                             SUM(CASE I.CDFISCALNF WHEN '1' THEN CONVERT(NUMERIC(12,2),I.VRIMPOSTONF)  ELSE 0 END) AS VRIMPOSTONF,
                                             SUM(CASE I.CDFISCALNF WHEN '2' THEN I.VRCONTABILNF          ELSE 0 END) AS VRISENTRIB,
                                             SUM(CASE I.CDFISCALNF WHEN '3' THEN CONVERT(NUMERIC(12,2),I.VRCONTABILNF) ELSE 0 END) AS VROUTRCRED

                                      FROM MAPAAPURAC M, NOTAFISCAL N, IMPOSTONF I, IMPOSTO P
                                      WHERE M.CDEMPRESA       = @P_CDEMPRESA                                 AND
                                            M.CDINSCESTA      = @P_CDINSCESTA                                AND
                                            M.DTINIPERIODO    = @P_DTINICIAL                                 AND
                                            M.DTFIMPERIODO    = @P_DTFINAL                                   AND
                                            M.CDIMPOSTO       = @P_CDIMPOSTO                                 AND
                                            I.NRSEQUMAPAPU    = M.NRSEQUMAPAPU                               AND
                                            I.CDIMPOSTO       = @P_CDIMPOSTO                                 AND
                                            I.CDIMPOSTO       = P.CDIMPOSTO                                  AND
                                            ISNULL(I.IDIMPOSTONF, '1') <> '3'                                AND
                                            N.CDFILIAL        = I.CDFILIAL                                   AND
                                            N.NRLANCTONF      = I.NRLANCTONF                                 AND
                                            ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E'))                       AND
                                            ISNULL(N.CDSERIE,' ')         <> 'ECF'                           AND
                                            N.CDMODDOCFISC IN ('06','21','22','27','28')
                                      GROUP BY CASE N.IDENTRSAIDOP WHEN 'E' THEN '0' ELSE '1' END,
                                               CASE N.IDORIGDESTNF WHEN 'F' THEN  N.CDFORNECED ELSE CASE N.IDORIGDESTNF WHEN 'C' THEN N.CDCLIENTE ELSE CASE N.IDENTRSAIDOP WHEN 'E' THEN N.CDFILIEMIT ELSE N.CDFILIRECE END END END,
                                               N.CDMODDOCFISC, CASE N.IDSTATUS WHEN 'C' THEN '02' ELSE '00' END, ISNULL(N.CDSERIE, N.CDSERIEENTR), N.NRNOTAFISC, CONVERT(VARCHAR,N.DTEMISSAO,103),
                                               N.NRLANCTBDOC, REPLACE(CONVERT(VARCHAR,N.DTENTRSAID,103), '/', ''), N.CDFILIAL, N.NRLANCTONF,P.CDIMPOSTRIB, N.CDFILIAL, N.NRLANCTONF, N.CDFORNECED, N.IDORIGDESTNF, N.DTEMISSAO, N.DTENTRSAID)  N,

                                     (SELECT COUNT(*) AS QTNFCANCEL                 				
                                      FROM MAPAAPURAC M, NOTAFISCAL N, IMPOSTONF I
                                      WHERE M.CDEMPRESA       = @P_CDEMPRESA                                 AND
                                            M.CDINSCESTA      = @P_CDINSCESTA                                AND
                                            M.DTINIPERIODO    = @P_DTINICIAL                                 AND
                                            M.DTFIMPERIODO    = @P_DTFINAL                                   AND
                                            M.CDIMPOSTO       = @P_CDIMPOSTO                                 AND
                                            I.NRSEQUMAPAPU    = M.NRSEQUMAPAPU                               AND
                                            I.CDIMPOSTO       = @P_CDIMPOSTO                                 AND
                                            ISNULL(I.IDIMPOSTONF, '1') <> '3'                                AND
                                            N.CDFILIAL        = I.CDFILIAL                                   AND
                                            N.NRLANCTONF      = I.NRLANCTONF                                 AND
                                            N.IDSTATUS        = 'C'                                          AND
                                            ISNULL(N.CDSERIE,' ')         <> 'ECF'                           AND
                                            ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E'))                       AND
                                            N.CDMODDOCFISC IN ('06','21','22','27','28')) CANC )
                               
     OPEN C_REGE100;

     WHILE (@@FETCH_STATUS = 0) BEGIN

          INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
          VALUES
           ('33'+RIGHT(REPLICATE('0',8)+RTRIM(@V_CONTREGE), 8), @C_ARQ_E100, @P_NRSEQARQMAG);
          SET @V_CONTREGE =  ISNULL(@V_CONTREGE,0) + 1;

          FETCH NEXT FROM C_REGE100 INTO @C_ARQ_E100, @C100_CDFILIAL, @C100_NRLANCTONF;

          DECLARE C_REGE105 CURSOR FOR (SELECT('|E105'                                                                          + '|' +
                                               ISNULL(N.CDFISCOPERNF, '')                                                                   + '|' +
                                               ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR, CONVERT(NUMERIC(12,2),N.VRCONTABILNF))), '.', ','),'0,00')    + '|' +
                                               ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR, CONVERT(NUMERIC(12,2),N.VRBASECALCNF))), '.', ','),'0,00')    + '|' +
                                               ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR, CONVERT(NUMERIC(12,2),N.VRALIQNF))), '.', ','),'0,00')        + '|' +
                                               ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR, CONVERT(NUMERIC(12,2),N.VRIMPOSTONF))), '.', ','),'0,00')     + '|' +
                                               ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR, CONVERT(NUMERIC(12,2),N.VRISENTRIB))), '.', ','),'0,00')      + '|' +
                                               ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR, CONVERT(NUMERIC(12,2),N.VROUTRCRED))), '.', ','),'0,00')      + '|'  ) AS ARQ_E105
                                        FROM (SELECT I.CDFISCOPERNF,
                                                     I.VRALIQNF,
                                                     ISNULL(SUM(CONVERT(NUMERIC(12,2),I.VRCONTABILNF)),0) AS VRCONTABILNF,
                                                     ISNULL(SUM(CASE I.CDFISCALNF WHEN '1' THEN CONVERT(NUMERIC(12,2),I.VRBASECALCNF) ELSE 0 END),0) AS VRBASECALCNF,
                                                     ISNULL(SUM(CASE I.CDFISCALNF WHEN '1' THEN CONVERT(NUMERIC(12,2),I.VRIMPOSTONF) ELSE 0 END),0)  AS VRIMPOSTONF,
                                                     ISNULL(SUM(CASE I.CDFISCALNF WHEN '3' THEN CONVERT(NUMERIC(12,2),I.VRCONTABILNF) ELSE 0 END),0) AS VROUTRCRED,
                                                     ISNULL(SUM(CASE I.CDFISCALNF WHEN '2' THEN I.VRCONTABILNF ELSE 0 END),0) AS VRISENTRIB
                                              FROM IMPOSTONF I
                                              WHERE I.CDFILIAL       = @C100_CDFILIAL      AND
                                                    I.NRLANCTONF     = @C100_NRLANCTONF    AND
                                                    I.NRSEQUMAPAPU   IS NOT NULL               AND
                                                    I.CDIMPOSTO      = @P_CDIMPOSTO    AND
                                                    ISNULL(I.IDIMPOSTONF, '1') <> '3'
                                              GROUP BY I.CDFISCOPERNF, I.VRALIQNF) N)
         OPEN C_REGE105;
 
         FETCH NEXT FROM C_REGE105 INTO @C_ARQ_E105;

         WHILE (@@FETCH_STATUS = 0) BEGIN

             INSERT INTO ARQMAGNETICO
               (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
             VALUES
               ('33'+RIGHT(REPLICATE('0',8)+RTRIM(@V_CONTREGE), 8), @C_ARQ_E105, @P_NRSEQARQMAG);
             SET @V_CONTREGE =  ISNULL(@V_CONTREGE,0) + 1;

             FETCH NEXT FROM C_REGE105 INTO @C_ARQ_E105;

          END;
          CLOSE C_REGE105;
          DEALLOCATE C_REGE105;

          FETCH NEXT FROM C_REGE100 INTO @C_ARQ_E100, @C100_CDFILIAL, @C100_NRLANCTONF;

   END;
   CLOSE C_REGE100;
   DEALLOCATE C_REGE100;

   /* REGISTRO E120 */
   DECLARE C_REGE120 CURSOR FOR (SELECT(/* 01 */   '|E120'                  									     + '|' +
                                        /* 02 */   ISNULL(N.IDENTRSAIDOP, '')             									     + '|' +
                                        /* 03 */   '0'                       								     	     + '|' +
                                        /* 04 */   ISNULL(N.IDORIG, '')                 									     + '|' +
                                        /* 05 */   ISNULL(N.CDMODDOCFISC, '')            		       						     	     + '|' +
                                        /* 06 */   ISNULL(N.IDSTATUS, '')                									     + '|' +		
                                        /* 07 */   ISNULL(N.CDSERIE, '')                  									     + '|' +
                                        /* 08 */   ''                         									     + '|' +
                                        /* 09 */   ISNULL(N.NRNOTAFISC, '')              									     + '|' +
                                        /* 10 */   ISNULL(N.DTEMISSAO, '')                									     + '|' +	
                                        /* 11 */   ISNULL(N.NRLANCTBDOC, '')              									     + '|' +
                                        /* 12 */   ISNULL(N.DTENTRSAID, '')               									     + '|' +
                                        /* 13 */   ISNULL(N.CDFISCOPERNF, '')            									     + '|' +
                                        /* 14 */   ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR, CONVERT(NUMERIC(12,2),N.VRCONTABILNF))), '.', ','),'0,00')  + '|' +
                                        /* 15 */   ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR, CONVERT(NUMERIC(12,2),N.VRBASECALCNF))), '.', ','),'0,00')  + '|' +
                                        /* 16 */   ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR, CONVERT(NUMERIC(12,2),N.VRALIQNF))), '.', ','),'0,00')      + '|' +
                                        /* 17 */   ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR, CONVERT(NUMERIC(12,2),N.VRIMPOSTONF))), '.', ','),'0,00')   + '|' +
                                        /* 18 */   ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR, CONVERT(NUMERIC(12,2),N.VRISENTRIB))), '.', ','),'0,00')    + '|' +
                                        /* 19 */   ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR, CONVERT(NUMERIC(12,2),N.VROUTRCRED))), '.', ','),'0,00')    + '|' +
                                        /* 20 */   ''                                                                                         + '|'  ) AS ARQ_E120,
                                        N.CDFILIAL, N.NRLANCTONF
                                 FROM(SELECT N.CDFILIAL, N.NRLANCTONF,
                                             CASE N.IDENTRSAIDOP WHEN 'E' THEN '0' ELSE '1' END  AS IDENTRSAIDOP,
                                             CASE N.IDORIGDESTNF WHEN 'F' THEN  N.CDFORNECED ELSE CASE N.IDORIGDESTNF WHEN 'C' THEN N.CDCLIENTE ELSE CASE N.IDENTRSAIDOP WHEN 'E' THEN N.CDFILIEMIT ELSE N.CDFILIRECE END END END AS IDORIG,
                                             N.CDMODDOCFISC,
                                             CASE N.IDSTATUS WHEN 'C' THEN '02' ELSE '00' END AS IDSTATUS,
                                             ISNULL(N.CDSERIE, N.CDSERIEENTR) AS CDSERIE,
                                             N.NRNOTAFISC, I.CDFISCOPERNF,
                                             CONVERT(VARCHAR,N.DTEMISSAO,103) AS DTEMISSAO,
                                             N.NRLANCTBDOC,
                                             CONVERT(VARCHAR,N.DTENTRSAID,103) AS DTENTRSAID,
                                             SUM(CONVERT(NUMERIC(12,2),I.VRALIQNF)) AS VRALIQNF,
                                             SUM(CONVERT(NUMERIC(12,2),I.VRCONTABILNF)) AS VRCONTABILNF,
                                             SUM(CASE I.CDFISCALNF WHEN '1' THEN CONVERT(NUMERIC(12,2),I.VRBASECALCNF) ELSE 0 END) AS VRBASECALCNF,
                                             SUM(CASE I.CDFISCALNF WHEN '1' THEN CONVERT(NUMERIC(12,2),I.VRIMPOSTONF)  ELSE 0 END) AS VRIMPOSTONF,
                                             SUM(CASE I.CDFISCALNF WHEN '2' THEN I.VRCONTABILNF 	     ELSE 0 END) AS VRISENTRIB,
                                             SUM(CASE I.CDFISCALNF WHEN '3' THEN CONVERT(NUMERIC(12,2),I.VRCONTABILNF) ELSE 0 END) AS VROUTRCRED

                                      FROM MAPAAPURAC M, NOTAFISCAL N, IMPOSTONF I, IMPOSTO P
                                      WHERE M.CDEMPRESA       = @P_CDEMPRESA                                 AND
                                            M.CDINSCESTA      = @P_CDINSCESTA                                AND
                                            M.DTINIPERIODO    = @P_DTINICIAL                                 AND
                                            M.DTFIMPERIODO    = @P_DTFINAL                                   AND
                                            M.CDIMPOSTO       = @P_CDIMPOSTO                                 AND
                                            I.NRSEQUMAPAPU    = M.NRSEQUMAPAPU                               AND
                                            I.CDIMPOSTO       = @P_CDIMPOSTO                                 AND
                                            I.CDIMPOSTO       = P.CDIMPOSTO                                  AND
                                            ISNULL(I.IDIMPOSTONF, '1') <> '3'                                AND
                                            N.CDFILIAL        = I.CDFILIAL                                   AND
                                            N.NRLANCTONF      = I.NRLANCTONF                                 AND
                                            ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E'))                       AND
                                            ISNULL(N.CDSERIE,' ')         <> 'ECF'                           AND
                                            N.CDMODDOCFISC IN ('07','08','09','10','11','26','18')
                                      GROUP BY CASE N.IDENTRSAIDOP WHEN 'E' THEN '0' ELSE '1' END,
                                               CASE N.IDORIGDESTNF WHEN 'F' THEN N.CDFORNECED ELSE CASE N.IDORIGDESTNF WHEN 'C' THEN N.CDCLIENTE ELSE CASE N.IDENTRSAIDOP WHEN 'E' THEN N.CDFILIEMIT ELSE N.CDFILIRECE END END END,
                                               CASE N.IDSTATUS WHEN 'C' THEN '02' ELSE '00' END, ISNULL(N.CDSERIE, N.CDSERIEENTR), N.NRNOTAFISC, REPLACE(CONVERT(VARCHAR,N.DTEMISSAO,103), '/', ''),
                                               N.NRLANCTBDOC, REPLACE(CONVERT(VARCHAR,N.DTENTRSAID,103), '/', ''), N.CDFILIAL, N.NRLANCTONF,P.CDIMPOSTRIB,
                                               N.CDFILIAL, N.NRLANCTONF, I.CDFISCOPERNF, N.CDMODDOCFISC, N.DTEMISSAO, N.DTENTRSAID )  N)
                              
   OPEN C_REGE120;
   FETCH NEXT FROM C_REGE120 INTO @C_ARQ_E120,  @C120_CDFILIAL,  @C120_NRLANCTONF;

   WHILE (@@FETCH_STATUS = 0) BEGIN

     INSERT INTO ARQMAGNETICO
       (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
     VALUES
       ('34'+RIGHT(REPLICATE('0',8)+RTRIM(@V_CONTREGE), 8), @C_ARQ_E120, @P_NRSEQARQMAG);
     SET @V_CONTREGE =  ISNULL(@V_CONTREGE,0) + 1;
     FETCH NEXT FROM C_REGE120 INTO @C_ARQ_E120,  @C120_CDFILIAL,  @C120_NRLANCTONF;
   
   END;
   CLOSE C_REGE120;
   DEALLOCATE C_REGE120;

   DECLARE C_REGE300 CURSOR FOR (SELECT ('|E300'                                             + '|' +
                                           REPLACE(CONVERT(VARCHAR,DTINIPERIODO,103), '/', '') + '|' +
                                           REPLACE(CONVERT(VARCHAR,DTFIMPERIODO,103), '/', '') + '|'  ) AS ARQ_E300,
                                           REPLACE(CONVERT(VARCHAR,DTINIPERIODO,103), '/', '') AS DTINICIAL,
                                           REPLACE(CONVERT(VARCHAR,DTFIMPERIODO,103), '/', '') AS DTFINAL
                                   FROM MAPAAPURAC
                                   WHERE  CDEMPRESA     = @P_CDEMPRESA                   AND
                                          CDINSCESTA    = @P_CDINSCESTA                  AND
                                          DTINIPERIODO  = @P_DTINICIAL                   AND
                                          DTFIMPERIODO  = @P_DTFINAL                     AND
                                          CDIMPOSTO     = @P_CDIMPOSTO)

   OPEN C_REGE300; 
   FETCH NEXT FROM C_REGE300 INTO @C_ARQ_E300, @C300_DTINICIAL, @C300_DTFINAL;

   WHILE (@@FETCH_STATUS = 0) BEGIN 

     INSERT INTO ARQMAGNETICO
       (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
     VALUES
       ('35'+RIGHT(REPLICATE('0',8)+RTRIM(@V_CONTREGE), 8), @C_ARQ_E300, @P_NRSEQARQMAG);
     SET @V_CONTREGE =  ISNULL(@V_CONTREGE,0) + 1;      


      DECLARE C_REGE310 CURSOR FOR (SELECT ('|E310'                                                                             + '|' +
                                            ISNULL(N.CDFISCOPERNF, '')                                                                                 + '|' +
                                            REPLACE(LTRIM(CONVERT(VARCHAR,ISNULL(CONVERT(NUMERIC(12,2),SUM(N.VRCONTABILNF)),0))),'.', ',') + '|' +
                                            REPLACE(LTRIM(CONVERT(VARCHAR,ISNULL(CONVERT(NUMERIC(12,2),SUM(N.VRBASECALCNF)),0))),'.', ',') + '|' +
                                            REPLACE(LTRIM(CONVERT(VARCHAR,ISNULL(CONVERT(NUMERIC(12,2),SUM(N.VRIMPOSTONF)) ,0))),'.', ',') + '|' +
                                            REPLACE(LTRIM(CONVERT(VARCHAR,ISNULL(CONVERT(NUMERIC(12,2),SUM(N.VRIMPOSUB))   ,0))),'.', ',') + '|' +
                                            '0'                                                                                            + '|' +
                                            REPLACE(LTRIM(CONVERT(VARCHAR,ISNULL(CONVERT(NUMERIC(12,2),SUM(N.VRISENTRIB)),0))),'.', ',')   + '|' +
                                            REPLACE(LTRIM(CONVERT(VARCHAR,ISNULL(CONVERT(NUMERIC(12,2),SUM(N.VROUTRCRED)),0))),'.', ',')   + '|'  ) AS ARQ_E310, 
                                            @C300_DTINICIAL
                                    FROM (SELECT I.CDFISCOPERNF,
                                                 SUM(I.VRCONTABILNF) AS VRCONTABILNF,
                                                 SUM(CASE I.CDFISCALNF WHEN '1' THEN CONVERT(NUMERIC(12,2),I.VRBASECALCNF) ELSE 0 END) AS VRBASECALCNF,
                                                 SUM(CASE I.CDFISCALNF WHEN '1' THEN CONVERT(NUMERIC(12,2),I.VRIMPOSTONF)  ELSE 0 END) AS VRIMPOSTONF,
                                                 SUM(CASE I.CDFISCALNF WHEN '3' THEN CONVERT(NUMERIC(12,2),I.VRCONTABILNF) ELSE 0 END) AS VROUTRCRED,
                                                 SUM(CASE I.CDFISCALNF WHEN '2' THEN I.VRCONTABILNF          ELSE 0 END) AS VRISENTRIB,
                                                 SUM(CONVERT(NUMERIC(12,2),TEKNISA.VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, P.CDIMPOSTRIB, 'I',I.CDFISCALNF))) AS VRIMPOSUB
                                          FROM MAPAAPURAC M, NOTAFISCAL N, IMPOSTONF I, IMPOSTO P
                                          WHERE M.CDEMPRESA       = @P_CDEMPRESA            AND
                                                M.CDINSCESTA      = @P_CDINSCESTA           AND
                                                REPLACE(CONVERT(VARCHAR, M.DTINIPERIODO,103), '/', '') = @C300_DTINICIAL         AND
                                                REPLACE(CONVERT(VARCHAR, M.DTFIMPERIODO,103), '/', '') = @C300_DTFINAL           AND
                                                M.CDIMPOSTO       = @P_CDIMPOSTO            AND
                                                I.NRSEQUMAPAPU    = M.NRSEQUMAPAPU          AND
                                                I.CDIMPOSTO       = @P_CDIMPOSTO            AND
                                                I.CDIMPOSTO       = P.CDIMPOSTO             AND
                                                ISNULL(I.IDIMPOSTONF, '1') <> '3'           AND
                                                N.CDFILIAL        = I.CDFILIAL              AND
                                                N.NRLANCTONF      = I.NRLANCTONF            AND
                                                N.IDENTRSAIDOP    = 'E'                     AND
                                                N.CDMODDOCFISC    IN ('01','02','04','06','07','08','09','10','11','26','18','21','22','27','28')    AND
                                                ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E'))
                                          GROUP BY I.CDFISCOPERNF
                                          UNION ALL
                                          SELECT I.CDFISCOPERNF,
                                                 SUM(I.VRCONTABILNF) AS VRCONTABILNF,
                                                 SUM(CASE I.CDFISCALNF WHEN '1' THEN CONVERT(NUMERIC(12,2),I.VRBASECALCNF) ELSE 0 END) AS VRBASECALCNF,
                                                 SUM(CASE I.CDFISCALNF WHEN '1' THEN CONVERT(NUMERIC(12,2),I.VRIMPOSTONF)  ELSE 0 END) AS VRIMPOSTONF,
                                                 SUM(CASE I.CDFISCALNF WHEN '3' THEN CONVERT(NUMERIC(12,2),I.VRCONTABILNF) ELSE 0 END) AS VROUTRCRED,
                                                 SUM(CASE I.CDFISCALNF WHEN '2' THEN I.VRCONTABILNF          ELSE 0 END) AS VRISENTRIB,
                                                 SUM(CONVERT(NUMERIC(12,2),TEKNISA.VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, P.CDIMPOSTRIB, 'I',I.CDFISCALNF))) AS VRIMPOSUB
                                          FROM MAPAAPURAC M, NOTAFISCAL N, IMPOSTONF I, IMPOSTO P
                                          WHERE M.CDEMPRESA       = @P_CDEMPRESA           AND
                                                M.CDINSCESTA      = @P_CDINSCESTA          AND
                                                REPLACE(CONVERT(VARCHAR, M.DTINIPERIODO,103), '/', '') = @C300_DTINICIAL         AND
                                                REPLACE(CONVERT(VARCHAR, M.DTFIMPERIODO,103), '/', '') = @C300_DTFINAL           AND
                                                M.CDIMPOSTO       = @P_CDIMPOSTO           AND
                                                I.NRSEQUMAPAPU    = M.NRSEQUMAPAPU         AND
                                                I.CDIMPOSTO       = @P_CDIMPOSTO           AND
                                                I.CDIMPOSTO       = P.CDIMPOSTO            AND
                                                ISNULL(I.IDIMPOSTONF, '1') <> '3'          AND
                                                N.CDFILIAL        = I.CDFILIAL             AND
                                                N.NRLANCTONF      = I.NRLANCTONF           AND
                                                N.CDSERIE         <> 'ECF'                 AND
                                                N.IDENTRSAIDOP    = 'S'                    AND
                                                N.CDMODDOCFISC    IN ('01','02','04','06','07','08','09','10','11','26','18','21','22','27','28')    AND
                                                ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E'))
                                          GROUP BY I.CDFISCOPERNF
                                          UNION ALL
                                          SELECT I.CDFISCOPERNF,
                                                 SUM(I.VRCONTABILNF) AS VRCONTABILNF,
                                                 SUM(CASE I.CDFISCALNF WHEN '1' THEN CONVERT(NUMERIC(12,2),I.VRBASECALCNF) ELSE 0 END) AS VRBASECALCNF,
                                                 SUM(CASE I.CDFISCALNF WHEN '1' THEN CONVERT(NUMERIC(12,2),I.VRIMPOSTONF) ELSE 0 END)  AS VRIMPOSTONF,
                                                 0 AS VROUTRCRED,
                                                 SUM(CASE I.CDFISCALNF WHEN '2' THEN I.VRCONTABILNF ELSE 0 END) AS VRISENTRIB,
                                                 SUM(CONVERT(NUMERIC(12,2),TEKNISA.VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, P.CDIMPOSTRIB, 'I',I.CDFISCALNF))) AS VRIMPOSUB
                                          FROM MAPAAPURAC M, NOTAFISCAL N, IMPOSTONF I, IMPOSTO P
                                          WHERE M.CDEMPRESA       = @P_CDEMPRESA           AND
                                                M.CDINSCESTA      = @P_CDINSCESTA          AND
                                                REPLACE(CONVERT(VARCHAR, M.DTINIPERIODO,103), '/', '') = @C300_DTINICIAL         AND
                                                REPLACE(CONVERT(VARCHAR, M.DTFIMPERIODO,103), '/', '') = @C300_DTFINAL           AND
                                                M.CDIMPOSTO       = @P_CDIMPOSTO           AND
                                                I.NRSEQUMAPAPU    = M.NRSEQUMAPAPU         AND
                                                I.CDIMPOSTO       = @P_CDIMPOSTO           AND
                                                I.CDIMPOSTO       = P.CDIMPOSTO            AND
                                                ISNULL(I.IDIMPOSTONF, '1') <> '3'          AND
                                                N.CDFILIAL        = I.CDFILIAL             AND
                                                N.NRLANCTONF      = I.NRLANCTONF           AND
                                                N.CDSERIE         = 'ECF'                  AND
                                                N.IDENTRSAIDOP    = 'S'                    AND
                                                ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E'))
                                          GROUP BY I.CDFISCOPERNF)N
                                    GROUP BY  N.CDFISCOPERNF)
                                    --ORDER BY N.CDFISCOPERNF)
     OPEN C_REGE310;

     FETCH NEXT FROM C_REGE310 INTO @C_ARQ_E310, @C300DTINICIAL;

     WHILE (@@FETCH_STATUS = 0) BEGIN
         INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           ('36'+RIGHT(REPLICATE('0',8)+RTRIM(@V_CONTREGE), 8), @C_ARQ_E310, @P_NRSEQARQMAG);
         SET @V_CONTREGE =  ISNULL(@V_CONTREGE,0) + 1;
         FETCH NEXT FROM C_REGE310 INTO @C_ARQ_E310, @C300DTINICIAL;
      END;

      CLOSE C_REGE310; 
      DEALLOCATE C_REGE310;


      DECLARE C_REGE320 CURSOR FOR (SELECT ('|E320'                                              				  + '|' +
                                            CASE NF.IDENTRSAIDOP WHEN 'E' THEN '0' ELSE '1' END  				  + '|' +
                                            ISNULL(NF.SGESTADO, '')                                         				  + '|' +
                                            REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),SUM(NF.VRCONTABILNF)))),'.', ',') + '|' +
                                            REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),SUM(NF.VRBASECALCNF)))),'.', ',') + '|' +
                                            REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),SUM(NF.VRIMPOSTONF )))),'.', ',') + '|' +
                                            '0'   										  + '|' +
                                            '0'     						 			          + '|' +
                                            REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),SUM(NF.VRISENTRIB)))),'.', ',')   + '|' +
                                            REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),SUM(NF.VROUTRCRED)))),'.', ',')   + '|'  ) AS ARQ_E320
                                    FROM(SELECT A.SGESTADO,
                                                A.IDENTRSAIDOP,
                                                SUM(A.VRCONTABILNF)  AS VRCONTABILNF,
                                                SUM(A.VRBASECALCNF)  AS VRBASECALCNF,
                                                SUM(A.VRIMPOSTONF)   AS VRIMPOSTONF,
                                                SUM(A.VROUTRCRED)    AS VROUTRCRED,
                                                SUM(A.VRISENTRIB)    AS VRISENTRIB
                                         FROM (SELECT MP.CDEMPRESA, MP.CDINSCESTA, NF.IDENTRSAIDOP,
                                                      MIN(MP.DTINIPERIODO) AS DTINIPERIODO,
                                                      MAX(MP.DTFIMPERIODO) AS DTFIMPERIODO,
                                                      SUM(A.VRCONTABILNF)  AS VRCONTABILNF,
                                                      SUM(A.VRBASECALCNF)  AS VRBASECALCNF,
                                                      SUM(A.VRIMPOSTONF)   AS VRIMPOSTONF,
                                                      SUM(A.VROUTRCRED)    AS VROUTRCRED,
                                                      SUM(A.VRISENTRIB)    AS VRISENTRIB,
                                                      EP.NMRAZSOCEMPR, IE.IDTPIJURIEST, IE.NRINSJURIEST,
                                                      SUBSTRING((ET.CDPAIS  +ETL.CDPAIS  +ETC.CDPAIS)  ,1,12) AS CDPAIS,
                                                      SUBSTRING((ET.SGESTADO+ETL.SGESTADO+ETC.SGESTADO),1,6)  AS SGESTADO,
                                                      SUBSTRING((ET.NMESTADO+ETL.NMESTADO+ETC.NMESTADO),1,90) AS NMESTADO
                                               FROM MAPAAPURAC MP, NOTAFISCAL NF, ENDEFORN EF,
                                                    EMPRESA EP, INSCRESTAD IE, ESTADO ET,
                                                    ENDECLIE EC, ENDEFILI EL,  ESTADO ETL, ESTADO ETC,
                                                    (SELECT B.NRSEQUMAPAPU, B.CDFILIAL, B.NRLANCTONF, B.CDFISCOPERNF,
                                                            SUM(CONVERT(NUMERIC(12,2),B.VRCONTABILNF)) AS VRCONTABILNF,
                                                            SUM(CONVERT(NUMERIC(12,2),B.VRBASECALCNF)) AS VRBASECALCNF,
                                                            SUM(CONVERT(NUMERIC(12,2),B.VRIMPOSTONF))  AS VRIMPOSTONF,
                                                            SUM(CONVERT(NUMERIC(12,2),B.VROUTRCRED))   AS VROUTRCRED,
                                                            SUM(CONVERT(NUMERIC(12,2),B.VRISENTRIB))   AS VRISENTRIB
                                                     FROM (SELECT NRSEQUMAPAPU, CDFILIAL, NRLANCTONF, CDFISCOPERNF,
                                                                  VRCONTABILNF, VRBASECALCNF, VRIMPOSTONF,
                                                                  0 AS VROUTRCRED, 0 AS VRISENTRIB
                                                           FROM  IMPOSTONF
                                                           WHERE CDFISCALNF = '1'        AND
                                                                 CDIMPOSTO  = @P_CDIMPOSTO AND
                                                                 ((IDIMPOSTONF <> '3') OR (IDIMPOSTONF IS NULL))
                                                           UNION
                                                           SELECT NRSEQUMAPAPU, CDFILIAL, NRLANCTONF, CDFISCOPERNF,
                                                                  VRCONTABILNF,     0 AS VRBASECALCNF,
                                                                  0 AS VRIMPOSTONF, 0 AS VROUTRCRED,
                                                                  VRCONTABILNF        AS VRISENTRIB
                                                           FROM  IMPOSTONF
                                                           WHERE CDFISCALNF = '2'        AND
                                                                 CDIMPOSTO  = @P_CDIMPOSTO AND
                                                                 ((IDIMPOSTONF <> '3') OR (IDIMPOSTONF IS NULL))
                                                           UNION
                                                           SELECT NRSEQUMAPAPU, CDFILIAL, NRLANCTONF, CDFISCOPERNF,
                                                                  VRCONTABILNF, 0    		 AS VRBASECALCNF,
                                                                  0 AS VRIMPOSTONF, VRCONTABILNF AS VROUTRCRED,
                                                                  			       0 AS VRISENTRIB
                                                           FROM  IMPOSTONF
                                                           WHERE CDFISCALNF = '3'        AND
                                                                 CDIMPOSTO  = @P_CDIMPOSTO AND
                                                                 ((IDIMPOSTONF <> '3') OR (IDIMPOSTONF IS NULL))
                                                           UNION
                                                           SELECT NRSEQUMAPAPU, CDFILIAL, NRLANCTONF, CDFISCOPERNF,
                                                                  0 AS VRCONTABILNF,
                                                                  0 AS VRBASECALCNF, 0 AS VRIMPOSTONF,
                                                                  VRIMPOSTONF	       AS VROUTRCRED,   0 AS VRISENTRIB
                                                           FROM  IMPOSTONF
                                                           WHERE CDIMPOSTO     <> @P_CDIMPOSTO AND
                                                                 IDIMPOSTONF = '4' ) B
                                                     GROUP BY B.NRSEQUMAPAPU, B.CDFILIAL, B.NRLANCTONF, B.CDFISCOPERNF) A	  
                                               WHERE (MP.CDEMPRESA       = @P_CDEMPRESA)    AND
                                                     (MP.CDINSCESTA      = @P_CDINSCESTA)   AND
                                                     (MP.CDIMPOSTO       = @P_CDIMPOSTO)    AND
                                                     (MP.DTINIPERIODO   >= @P_DTINICIAL)    AND
                                                     (MP.DTFIMPERIODO   <= @P_DTFINAL)      AND
                                                     (MP.NRSEQUMAPAPU    = A.NRSEQUMAPAPU)  AND
                                                     (A.CDFILIAL         = NF.CDFILIAL)     AND
                                                     (A.NRLANCTONF       = NF.NRLANCTONF)   AND
                                                     (EF.CDFORNECED      = NF.CDFORNECED)   AND
                                                     (EC.CDCLIENTE       = NF.CDCLIENTE)    AND
                                                     (EL.CDFILIAL        = NF.CDFILIRECE)   AND
                                                     (EF.IDTPENDEFORN    = 'P')             AND
                                                     (EC.IDTPENDECLIE    = 'P')             AND
                                                     (EL.IDTPENDEFILI    = 'P')             AND
                                                     (EP.CDEMPRESA       = MP.CDEMPRESA)    AND
                                                     (IE.CDEMPRESA       = MP.CDEMPRESA)    AND
                                                     (IE.CDINSCESTA      = MP.CDINSCESTA)   AND
                                                     (ET.CDPAIS          = EF.CDPAIS)       AND
                                                     (ET.SGESTADO        = EF.SGESTADO)     AND
                                                     (ETL.CDPAIS         = EL.CDPAIS)       AND
                                                     (ETL.SGESTADO       = EL.SGESTADO)     AND
                                                     (ETC.CDPAIS         = EC.CDPAIS)       AND
                                                     (NF.IDENTRSAIDOP    = 'S')             AND
                                                     (NF.CDSERIE         = 'ECF')           AND
                                                     (NF.CDMODDOCFISC    IN ('01','02','04','06','07','08','09','10','11','26','18','21','22','27','28'))    AND
                                                     (ETC.SGESTADO       = EC.SGESTADO)
                                               GROUP BY MP.CDEMPRESA, MP.CDINSCESTA, EP.NMRAZSOCEMPR, NF.IDENTRSAIDOP,
                                                        IE.IDTPIJURIEST, IE.NRINSJURIEST,
                                                        ET.CDPAIS, ETL.CDPAIS, ETC.CDPAIS,
                                                        ET.SGESTADO, ETL.SGESTADO, ETC.SGESTADO,
                                                        ET.NMESTADO, ETL.NMESTADO, ETC.NMESTADO) A
                                         GROUP BY A.SGESTADO, A.IDENTRSAIDOP
                                         UNION ALL
                                         SELECT A.SGESTADO,
                                                A.IDENTRSAIDOP,
                                                SUM(A.VRCONTABILNF)  AS VRCONTABILNF,
                                                SUM(A.VRBASECALCNF)  AS VRBASECALCNF,
                                                SUM(A.VRIMPOSTONF)   AS VRIMPOSTONF,
                                                SUM(A.VROUTRCRED)    AS VROUTRCRED,
                                                SUM(A.VRISENTRIB)    AS VRISENTRIB
                                         FROM (SELECT MP.CDEMPRESA, MP.CDINSCESTA, NF.IDENTRSAIDOP,
                                                      MIN(MP.DTINIPERIODO) AS DTINIPERIODO,
                                                      MAX(MP.DTFIMPERIODO) AS DTFIMPERIODO,
                                                      SUM(A.VRCONTABILNF)  AS VRCONTABILNF,
                                                      SUM(A.VRBASECALCNF)  AS VRBASECALCNF,
                                                      SUM(A.VRIMPOSTONF)   AS VRIMPOSTONF,
                                                      SUM(A.VROUTRCRED)    AS VROUTRCRED,
                                                      SUM(A.VRISENTRIB)    AS VRISENTRIB,
                                                      EP.NMRAZSOCEMPR, IE.IDTPIJURIEST, IE.NRINSJURIEST,
                                                      SUBSTRING((ET.CDPAIS  +ETL.CDPAIS  +ETC.CDPAIS)  ,1,12) AS CDPAIS,
                                                      SUBSTRING((ET.SGESTADO+ETL.SGESTADO+ETC.SGESTADO),1,6)  AS SGESTADO,
                                                      SUBSTRING((ET.NMESTADO+ETL.NMESTADO+ETC.NMESTADO),1,90) AS NMESTADO
                                               FROM MAPAAPURAC MP, NOTAFISCAL NF, ENDEFORN EF,
                                                    EMPRESA EP, INSCRESTAD IE, ESTADO ET,
                                                    ENDECLIE EC, ENDEFILI EL,  ESTADO ETL, ESTADO ETC,
                                                    (SELECT B.NRSEQUMAPAPU, B.CDFILIAL, B.NRLANCTONF, B.CDFISCOPERNF,
                                                            SUM(CONVERT(NUMERIC(12,2),B.VRCONTABILNF)) AS VRCONTABILNF,
                                                            SUM(CONVERT(NUMERIC(12,2),B.VRBASECALCNF)) AS VRBASECALCNF,
                                                            SUM(CONVERT(NUMERIC(12,2),B.VRIMPOSTONF))  AS VRIMPOSTONF,
                                                            SUM(CONVERT(NUMERIC(12,2),B.VROUTRCRED))   AS VROUTRCRED,
                                                            SUM(CONVERT(NUMERIC(12,2),B.VRISENTRIB))   AS VRISENTRIB
                                                     FROM (SELECT NRSEQUMAPAPU, CDFILIAL, NRLANCTONF, CDFISCOPERNF,
                                                                  VRCONTABILNF, VRBASECALCNF, VRIMPOSTONF,
                                                                  0 AS VROUTRCRED, 0 AS VRISENTRIB
                                                           FROM  IMPOSTONF
                                                           WHERE CDFISCALNF = '1'        AND
                                                                 CDIMPOSTO  = @P_CDIMPOSTO         AND
                                                                 ((IDIMPOSTONF <> '3') OR (IDIMPOSTONF IS NULL))
                                                           UNION
                                                           SELECT NRSEQUMAPAPU, CDFILIAL, NRLANCTONF, CDFISCOPERNF,
                                                                  VRCONTABILNF, 0 AS VRBASECALCNF,
                                                                  0 AS VRIMPOSTONF, 0 AS VROUTRCRED,
                                                                  VRCONTABILNF AS VRISENTRIB
                                                           FROM  IMPOSTONF
                                                           WHERE CDFISCALNF = '2'        AND
                                                                 CDIMPOSTO  = @P_CDIMPOSTO         AND
                                                                 ((IDIMPOSTONF <> '3') OR (IDIMPOSTONF IS NULL))
                                                           UNION
                                                           SELECT NRSEQUMAPAPU, CDFILIAL, NRLANCTONF, CDFISCOPERNF,
                                                                  VRCONTABILNF, 0 AS VRBASECALCNF,
                                                                  0 AS VRIMPOSTONF, VRCONTABILNF AS VROUTRCRED,
                                                                  0 AS VRISENTRIB
                                                           FROM  IMPOSTONF
                                                           WHERE CDFISCALNF = '3'        AND
                                                                 CDIMPOSTO  = @P_CDIMPOSTO         AND
                                                                 ((IDIMPOSTONF <> '3') OR (IDIMPOSTONF IS NULL))
                                                           UNION
                                                           SELECT NRSEQUMAPAPU, CDFILIAL, NRLANCTONF, CDFISCOPERNF,
                                                                  0 AS VRCONTABILNF,
                                                                  0 AS VRBASECALCNF, 0 AS VRIMPOSTONF,
                                                                  VRIMPOSTONF AS VROUTRCRED,   0 AS VRISENTRIB
                                                           FROM  IMPOSTONF
                                                           WHERE CDIMPOSTO     <> @P_CDIMPOSTO AND
                                                                 IDIMPOSTONF = '4') B
                                                     GROUP BY B.NRSEQUMAPAPU, B.CDFILIAL, B.NRLANCTONF, B.CDFISCOPERNF) A
                                               WHERE (MP.CDEMPRESA       = @P_CDEMPRESA)      AND
                                                     (MP.CDINSCESTA      = @P_CDINSCESTA)     AND
                                                     (MP.CDIMPOSTO       = @P_CDIMPOSTO)      AND
                                                     (MP.DTINIPERIODO   >= @P_DTINICIAL)      AND
                                                     (MP.DTFIMPERIODO   <= @P_DTFINAL)        AND
                                                     (MP.NRSEQUMAPAPU    = A.NRSEQUMAPAPU)    AND
                                                     (A.CDFILIAL         = NF.CDFILIAL)       AND
                                                     (A.NRLANCTONF       = NF.NRLANCTONF)     AND
                                                     (EF.CDFORNECED   = NF.CDFORNECED)        AND
                                                     (EC.CDCLIENTE    = NF.CDCLIENTE)         AND
                                                     (EL.CDFILIAL    = NF.CDFILIRECE)         AND
                                                     (EF.IDTPENDEFORN = 'P')                  AND
                                                     (EC.IDTPENDECLIE = 'P')                  AND
                                                     (EL.IDTPENDEFILI = 'P')                  AND
                                                     (EP.CDEMPRESA       = MP.CDEMPRESA)      AND
                                                     (IE.CDEMPRESA       = MP.CDEMPRESA)      AND
                                                     (IE.CDINSCESTA      = MP.CDINSCESTA)     AND
                                                     (ET.CDPAIS       = EF.CDPAIS)            AND
                                                     (ET.SGESTADO     = EF.SGESTADO)          AND
                                                     (ETL.CDPAIS      = EL.CDPAIS)            AND
                                                     (ETL.SGESTADO    = EL.SGESTADO)          AND
                                                     (ETC.CDPAIS      = EC.CDPAIS)            AND
                                                     (NF.IDENTRSAIDOP    = 'S')               AND
                                                     (NF.CDSERIE         <> 'ECF')            AND
                                                     (NF.CDMODDOCFISC    IN ('01','02','04','06','07','08','09','10','11','26','18','21','22','27','28'))    AND
                                                     (ETC.SGESTADO    = EC.SGESTADO)
                                               GROUP BY MP.CDEMPRESA, MP.CDINSCESTA, EP.NMRAZSOCEMPR, NF.IDENTRSAIDOP,
                                                        IE.IDTPIJURIEST, IE.NRINSJURIEST,
                                                        ET.CDPAIS, ETL.CDPAIS, ETC.CDPAIS,
                                                        ET.SGESTADO, ETL.SGESTADO, ETC.SGESTADO,
                                                        ET.NMESTADO, ETL.NMESTADO, ETC.NMESTADO) A
                                         GROUP BY A.SGESTADO, A.IDENTRSAIDOP
                                         UNION ALL
                                         SELECT A.SGESTADO,
                                                A.IDENTRSAIDOP,
                                                SUM(A.VRCONTABILNF)          AS VRCONTABILNF,
                                                SUM(A.VRBASECALCNF)          AS VRBASECALCNF,
                                                SUM(A.VRIMPOSTONF)           AS VRIMPOSTONF,
                                                SUM(A.VROUTRCRED)            AS VROUTRCRED,
                                                SUM(A.VRISENTRIB)            AS VRISENTRIB
                                         FROM (SELECT MP.CDEMPRESA, MP.CDINSCESTA, NF.IDENTRSAIDOP,
                                                      MIN(MP.DTINIPERIODO) AS DTINIPERIODO,
                                                      MAX(MP.DTFIMPERIODO) AS DTFIMPERIODO,
                                                      SUM(A.VRCONTABILNF)  AS VRCONTABILNF,
                                                      SUM(A.VRBASECALCNF)  AS VRBASECALCNF,
                                                      SUM(A.VRIMPOSTONF)   AS VRIMPOSTONF,
                                                      SUM(A.VROUTRCRED)    AS VROUTRCRED,
                                                      SUM(A.VRISENTRIB)    AS VRISENTRIB,
                                                      EP.NMRAZSOCEMPR, IE.IDTPIJURIEST, IE.NRINSJURIEST,
                                                      SUBSTRING((ET.CDPAIS  +ETL.CDPAIS  +ETC.CDPAIS)  ,1,12) AS CDPAIS,
                                                      SUBSTRING((ET.SGESTADO+ETL.SGESTADO+ETC.SGESTADO),1,6)  AS SGESTADO,
                                                      SUBSTRING((ET.NMESTADO+ETL.NMESTADO+ETC.NMESTADO),1,90) AS NMESTADO,
						      CONVERT(DATETIME, @P_DTINICIAL)  AS DTINICIAL,
                                                      CONVERT(DATETIME, @P_DTFINAL)    AS DTFINAL
                                               FROM MAPAAPURAC MP, NOTAFISCAL NF, ENDEFORN EF,
                                                    EMPRESA EP, INSCRESTAD IE, ESTADO ET,
                                                    ENDECLIE EC, ENDEFILI EL,  ESTADO ETL, ESTADO ETC,
                                                  (SELECT MP.CDEMPRESA, MP.CDINSCESTA,
                                                          I.NRSEQUMAPAPU, I.CDFILIAL, I.NRLANCTONF, CDFISCOPERNF,
                                                          MIN(MP.DTINIPERIODO) AS DTINIPERIODO,
                                                          MAX(MP.DTFIMPERIODO) AS DTFIMPERIODO,
                                                          SUM(CONVERT(NUMERIC(12,2),VRCONTABILNF)) AS VRCONTABILNF,
                                                          SUM(CONVERT(NUMERIC(12,2),CASE CDFISCALNF WHEN '1' THEN VRBASECALCNF ELSE 0 END)) AS VRBASECALCNF,
                                                          SUM(CONVERT(NUMERIC(12,2),CASE CDFISCALNF WHEN '1' THEN VRIMPOSTONF  ELSE 0 END)) AS VRIMPOSTONF,
                                                          SUM(CONVERT(NUMERIC(12,2),CASE CDFISCALNF WHEN '3' THEN VRCONTABILNF ELSE 0 END)) AS VROUTRCRED,
                                                          SUM(CONVERT(NUMERIC(12,2),CASE CDFISCALNF WHEN '2' THEN VRCONTABILNF ELSE  CASE CDFISCALNF   WHEN  1  THEN     CASE VRBASECALCNF WHEN  0  THEN 0 ELSE VRCONTABILNF - VRBASECALCNF END ELSE 0 END END)) AS VRISENTRIB
                                                   FROM IMPOSTONF I, MAPAAPURAC MP
                                                   WHERE (MP.CDEMPRESA       = @P_CDEMPRESA)                 AND
                                                         (MP.CDINSCESTA      = @P_CDINSCESTA)                AND
                                                         (MP.CDIMPOSTO       = @P_CDIMPOSTO)                 AND
                                                         (MP.DTINIPERIODO   >= @P_DTINICIAL)                 AND
                                                         (MP.DTFIMPERIODO   <= @P_DTFINAL)                   AND
                                                         (MP.NRSEQUMAPAPU    = I.NRSEQUMAPAPU)               AND
                                                         (I.CDIMPOSTO BETWEEN @P_CDIMPOSTO AND @P_CDIMPOSTO) AND
                                                         ((IDIMPOSTONF <> '3') OR (IDIMPOSTONF IS NULL))
                                                   GROUP BY MP.CDEMPRESA, MP.CDINSCESTA, I.NRSEQUMAPAPU,
                                                            I.CDFILIAL, I.NRLANCTONF, CDFISCOPERNF, MP.DTINIPERIODO, MP.DTFIMPERIODO
                                                   UNION
                                                   SELECT MP.CDEMPRESA, MP.CDINSCESTA,
                                                          I.NRSEQUMAPAPU, I.CDFILIAL, I.NRLANCTONF, CDFISCOPERNF,
                                                          MP.DTINIPERIODO,
                                                          MP.DTFIMPERIODO,
                                                          0 AS VRCONTABILNF,
                                                          0 AS VRBASECALCNF, 0 AS VRIMPOSTONF,
                                                          SUM(CONVERT(NUMERIC(12,2),VRIMPOSTONF)) AS VROUTRCRED,   0 AS VRISENTRIB
                                                   FROM IMPOSTONF I, MAPAAPURAC MP
                                                   WHERE (MP.CDEMPRESA     = @P_CDEMPRESA)               AND
                                                         (MP.CDINSCESTA    = @P_CDINSCESTA)              AND
                                                         (MP.CDIMPOSTO     = @P_CDIMPOSTO)             	 AND
                                                         (MP.DTINIPERIODO >= @P_DTINICIAL)               AND
                                                         (MP.DTFIMPERIODO <= @P_DTFINAL)                 AND
                                                         (MP.NRSEQUMAPAPU  = I.NRSEQUMAPAPU)             AND
                                                         (I.CDIMPOSTO     <> @P_CDIMPOSTO)          	 AND
                                                         (IDIMPOSTONF      = '4')
                                                   GROUP BY MP.CDEMPRESA, MP.CDINSCESTA, I.NRSEQUMAPAPU,
                                                            I.CDFILIAL, I.NRLANCTONF, CDFISCOPERNF, MP.DTINIPERIODO, MP.DTFIMPERIODO) A
                                               WHERE (MP.CDEMPRESA     =  @P_CDEMPRESA)     AND
                                                     (MP.CDINSCESTA    =  @P_CDINSCESTA)    AND
                                                     (MP.CDIMPOSTO     =  @P_CDIMPOSTO)     AND
                                                     (MP.DTINIPERIODO  >= @P_DTINICIAL)     AND
                                                     (MP.DTFIMPERIODO  <= @P_DTFINAL)       AND
                                                     (MP.NRSEQUMAPAPU  =  A.NRSEQUMAPAPU)    AND
                                                     (A.CDFILIAL       =  NF.CDFILIAL)      AND
                                                     (A.NRLANCTONF     =  NF.NRLANCTONF)    AND
                                                     (EF.CDFORNECED    =  NF.CDFORNECED)    AND
                                                     (EC.CDCLIENTE     =  NF.CDCLIENTE)     AND
                                                     (EL.CDFILIAL      =  NF.CDFILIEMIT)    AND
                                                     (EF.IDTPENDEFORN  =  'P')              AND
                                                     (EC.IDTPENDECLIE  =  'P')              AND
                                                     (EL.IDTPENDEFILI  =  'P')              AND
                                                     (EP.CDEMPRESA     =  MP.CDEMPRESA)     AND
                                                     (IE.CDEMPRESA     =  MP.CDEMPRESA)     AND
                                                     (IE.CDINSCESTA    =  MP.CDINSCESTA)    AND
                                                     (ET.CDPAIS        =  EF.CDPAIS)        AND
                                                     (ET.SGESTADO      =  EF.SGESTADO)      AND
                                                     (ETL.CDPAIS       =  EL.CDPAIS)        AND
                                                     (ETL.SGESTADO     =  EL.SGESTADO)      AND
                                                     (ETC.CDPAIS       =  EC.CDPAIS)        AND
                                                     (NF.CDMODDOCFISC  IN ('01','02','04','06','07','08','09','10','11','26','18','21','22','27','28'))    AND
                                                     (NF.IDENTRSAIDOP  = 'E')               AND
                                                     (ETC.SGESTADO     = EC.SGESTADO)
                                               GROUP BY MP.CDEMPRESA,    MP.CDINSCESTA, EP.NMRAZSOCEMPR, NF.IDENTRSAIDOP,
                                                        IE.IDTPIJURIEST, IE.NRINSJURIEST,
                                                        ET.CDPAIS,       ETL.CDPAIS, ETC.CDPAIS,
                                                        ET.SGESTADO,     ETL.SGESTADO, ETC.SGESTADO,
                                                        ET.NMESTADO,     ETL.NMESTADO, ETC.NMESTADO) A
                                         GROUP BY A.SGESTADO, A.IDENTRSAIDOP)  NF                                       
                                   GROUP BY NF.IDENTRSAIDOP, NF.SGESTADO) 
     OPEN C_REGE320;
    
     FETCH NEXT FROM C_REGE320 INTO @C_ARQ_E320;

     WHILE (@@FETCH_STATUS = 0) BEGIN

         INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           ('37'+RIGHT(REPLICATE('0',8)+RTRIM(@V_CONTREGE), 8), @C_ARQ_E320, @P_NRSEQARQMAG);
         SET @V_CONTREGE =  ISNULL(@V_CONTREGE,0) + 1;

         FETCH NEXT FROM C_REGE320 INTO @C_ARQ_E320;

      END;
      CLOSE C_REGE320;
      DEALLOCATE C_REGE320;
     
      DECLARE C_REGE330 CURSOR FOR (SELECT ('|E330'                                                                          + '|' +
                                            '1'                                                                              + '|' +
                                            ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,SUM(CONVERT(NUMERIC(12,2),N.VRCONTABILNF)))), '.', ','),'0,00') + '|' +
                                            ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,SUM(CONVERT(NUMERIC(12,2),N.VRBASECALCNF)))), '.', ','),'0,00') + '|' +
                                            ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,SUM(CONVERT(NUMERIC(12,2),N.VRIMPOSTONF)))), '.', ','),'0,00')  + '|' +
                                            ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,SUM(CONVERT(NUMERIC(12,2),N.VRIMPOSUB)))), '.', ','),'0,00')    + '|' +
                                            '0'                                                                              			 + '|' +
                                            ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,SUM(CONVERT(NUMERIC(12,2),VRISENTRIB)))), '.', ','),'0,00')     + '|' +
                                            ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,SUM(CONVERT(NUMERIC(12,2),VROUTRCRED)))), '.', ','),'0,00')     + '|'  ) AS ARQ_E330

                                    FROM(SELECT SUM(CONVERT(NUMERIC(12,2),I.VRCONTABILNF)) AS VRCONTABILNF,
                                                SUM(CASE I.CDFISCALNF WHEN '1' THEN CONVERT(NUMERIC(12,2),I.VRBASECALCNF) ELSE 0 END) AS VRBASECALCNF,
                                                SUM(CASE I.CDFISCALNF WHEN '1' THEN CONVERT(NUMERIC(12,2),I.VRIMPOSTONF)  ELSE 0 END) AS VRIMPOSTONF,
                                                SUM(CASE I.CDFISCALNF WHEN '3' THEN CONVERT(NUMERIC(12,2),I.VRCONTABILNF) ELSE 0 END) AS VROUTRCRED,
                                                SUM(CASE I.CDFISCALNF WHEN '2' THEN CONVERT(NUMERIC(12,2),I.VRCONTABILNF) ELSE 0 END) AS VRISENTRIB,
                                                SUM(CONVERT(NUMERIC(12,2),TEKNISA.VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, P.CDIMPOSTRIB, 'I', I.CDFISCALNF))) AS VRIMPOSUB

                                         FROM MAPAAPURAC M, NOTAFISCAL N, IMPOSTONF I, IMPOSTO P
                                         WHERE M.CDEMPRESA       = @P_CDEMPRESA           AND
                                               M.CDINSCESTA      = @P_CDINSCESTA          AND
                                               REPLACE(CONVERT(VARCHAR, M.DTINIPERIODO,103), '/', '') = @C300_DTINICIAL         AND
                                               REPLACE(CONVERT(VARCHAR, M.DTFIMPERIODO,103), '/', '') = @C300_DTFINAL           AND
                                               M.CDIMPOSTO       = @P_CDIMPOSTO           AND
                                               I.NRSEQUMAPAPU    = M.NRSEQUMAPAPU         AND
                                               I.CDIMPOSTO       = @P_CDIMPOSTO           AND
                                               I.CDIMPOSTO       = P.CDIMPOSTO            AND
                                               SUBSTRING(I.CDFISCOPERNF,1,1) = '1'        AND
                                               ISNULL(I.IDIMPOSTONF, '1') <> '3'          AND
                                               N.CDFILIAL        = I.CDFILIAL             AND
                                               N.NRLANCTONF      = I.NRLANCTONF           AND
                                               ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E')) AND
                                               N.CDMODDOCFISC    IN ('01','02','04','06','07','08','09','10','11','26','18','21','22','27','28')    AND
                                               N.IDENTRSAIDOP     = 'E'                    )N
                                    UNION ALL
                                    SELECT ('|E330'                                                                          + '|' +
                                            '2'                                                                              + '|' +
                                            ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,SUM(CONVERT(NUMERIC(12,2),N.VRCONTABILNF)))), '.', ','),'0,00')    + '|' +
                                            ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,SUM(CONVERT(NUMERIC(12,2),N.VRBASECALCNF)))), '.', ','),'0,00')    + '|' +
                                            ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,SUM(CONVERT(NUMERIC(12,2),N.VRIMPOSTONF)))), '.', ','),'0,00')     + '|' +
                                            ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,SUM(CONVERT(NUMERIC(12,2),N.VRIMPOSUB)))), '.', ','),'0,00')       + '|' +
                                            '0'                                                                              + '|' +
                                            ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,SUM(CONVERT(NUMERIC(12,2),VRISENTRIB)))), '.', ','),'0,00')        + '|' +
                                            ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,SUM(CONVERT(NUMERIC(12,2),VROUTRCRED)))), '.', ','),'0,00')        + '|'  ) AS ARQ_E330

                                    FROM(SELECT SUM(CONVERT(NUMERIC(12,2),I.VRCONTABILNF)) AS VRCONTABILNF,
                                                SUM(CASE I.CDFISCALNF WHEN '1' THEN CONVERT(NUMERIC(12,2),I.VRBASECALCNF) ELSE 0 END) AS VRBASECALCNF,
                                                SUM(CASE I.CDFISCALNF WHEN '1' THEN CONVERT(NUMERIC(12,2),I.VRIMPOSTONF)  ELSE 0 END)  AS VRIMPOSTONF,
                                                SUM(CASE I.CDFISCALNF WHEN '3' THEN CONVERT(NUMERIC(12,2),I.VRCONTABILNF) ELSE 0 END)   AS VROUTRCRED,
                                                SUM(CASE I.CDFISCALNF WHEN '2' THEN CONVERT(NUMERIC(12,2),I.VRCONTABILNF) ELSE 0 END) AS VRISENTRIB,
                                                SUM(CONVERT(NUMERIC(12,2),TEKNISA.VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, P.CDIMPOSTRIB, 'I', I.CDFISCALNF))) AS VRIMPOSUB
                                         FROM MAPAAPURAC M, NOTAFISCAL N, IMPOSTONF I, IMPOSTO P
                                         WHERE M.CDEMPRESA       = @P_CDEMPRESA            AND
                                               M.CDINSCESTA      = @P_CDINSCESTA           AND
                                               REPLACE(CONVERT(VARCHAR, M.DTINIPERIODO,103), '/', '') = @C300_DTINICIAL         AND
                                               REPLACE(CONVERT(VARCHAR, M.DTFIMPERIODO,103), '/', '') = @C300_DTFINAL           AND
                                               M.CDIMPOSTO       = @P_CDIMPOSTO            AND
                                               I.NRSEQUMAPAPU    = M.NRSEQUMAPAPU          AND
                                               I.CDIMPOSTO       = @P_CDIMPOSTO            AND
                                               I.CDIMPOSTO       = P.CDIMPOSTO             AND
                                               SUBSTRING(I.CDFISCOPERNF,1,1) = '2'         AND
                                               ISNULL(I.IDIMPOSTONF, '1') <> '3'           AND
                                               N.CDFILIAL        = I.CDFILIAL              AND
                                               N.NRLANCTONF      = I.NRLANCTONF            AND
                                               ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E'))  AND
                                               N.CDMODDOCFISC    IN ('01','02','04','06','07','08','09','10','11','26','18','21','22','27','28')    AND
                                               N.IDENTRSAIDOP    = 'E'                    )N
                                    UNION ALL
                                    SELECT ('|E330'                                                                       + '|' +
                                            '3'                                                                           + '|' +
                                            ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,SUM(CONVERT(NUMERIC(12,2),N.VRCONTABILNF)))), '.', ','),'0,00') + '|' +
                                            ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,SUM(CONVERT(NUMERIC(12,2),N.VRBASECALCNF)))), '.', ','),'0,00') + '|' +
                                            ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,SUM(CONVERT(NUMERIC(12,2),N.VRIMPOSTONF)))), '.', ','),'0,00')  + '|' +
                                            ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,SUM(CONVERT(NUMERIC(12,2),N.VRIMPOSUB)))), '.', ','),'0,00')    + '|' +
                                            '0'                                                                           + '|' +
                                            ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,SUM(CONVERT(NUMERIC(12,2),VRISENTRIB)))), '.', ','),'0,00')     + '|' +
                                            ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,SUM(CONVERT(NUMERIC(12,2),VROUTRCRED)))), '.', ','),'0,00')     + '|'  ) AS ARQ_E330

                                    FROM (SELECT SUM(CONVERT(NUMERIC(12,2),I.VRCONTABILNF)) AS VRCONTABILNF,
                                                 SUM(CASE I.CDFISCALNF WHEN '1' THEN CONVERT(NUMERIC(12,2),I.VRBASECALCNF) ELSE 0 END) AS VRBASECALCNF,
                                                 SUM(CASE I.CDFISCALNF WHEN '1' THEN CONVERT(NUMERIC(12,2),I.VRIMPOSTONF)  ELSE 0 END)  AS VRIMPOSTONF,
                                                 SUM(CASE I.CDFISCALNF WHEN '3' THEN CONVERT(NUMERIC(12,2),I.VRCONTABILNF) ELSE 0 END)   AS VROUTRCRED,
                                                 SUM(CASE I.CDFISCALNF WHEN '2' THEN CONVERT(NUMERIC(12,2),I.VRCONTABILNF) ELSE 0 END) AS VRISENTRIB,
                                                 SUM(CONVERT(NUMERIC(12,2),TEKNISA.VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, P.CDIMPOSTRIB, 'I', I.CDFISCALNF))) AS VRIMPOSUB

                                          FROM MAPAAPURAC M, NOTAFISCAL N, IMPOSTONF I, IMPOSTO P
                                          WHERE M.CDEMPRESA       = @P_CDEMPRESA            AND
                                                M.CDINSCESTA      = @P_CDINSCESTA           AND
                                                REPLACE(CONVERT(VARCHAR, M.DTINIPERIODO,103), '/', '') = @C300_DTINICIAL         AND
                                                REPLACE(CONVERT(VARCHAR, M.DTFIMPERIODO,103), '/', '') = @C300_DTFINAL           AND
                                                M.CDIMPOSTO       = @P_CDIMPOSTO            AND
                                                I.NRSEQUMAPAPU    = M.NRSEQUMAPAPU          AND
                                                I.CDIMPOSTO       = @P_CDIMPOSTO            AND
                                                I.CDIMPOSTO       = P.CDIMPOSTO             AND
                                                SUBSTRING(I.CDFISCOPERNF,1,1) = '3'         AND
                                                ISNULL(I.IDIMPOSTONF, '1') <> '3'           AND
                                                N.CDFILIAL        = I.CDFILIAL              AND
                                                N.NRLANCTONF      = I.NRLANCTONF            AND
                                                ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E'))  AND
                                                N.CDMODDOCFISC    IN ('01','02','04','06','07','08','09','10','11','26','18','21','22','27','28')    AND
                                                N.IDENTRSAIDOP    = 'E'                    )N
                                    UNION ALL
                                    SELECT ('|E330'                                                                          + '|' +
                                            '4'                                                                              + '|' +
                                            ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,SUM(CONVERT(NUMERIC(12,2),N.VRCONTABILNF)))), '.', ','),'0,00')    + '|' +
                                            ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,SUM(CONVERT(NUMERIC(12,2),N.VRBASECALCNF)))), '.', ','),'0,00')    + '|' +
                                            ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,SUM(CONVERT(NUMERIC(12,2),N.VRIMPOSTONF)))), '.', ','),'0,00')    + '|' +
                                            ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,SUM(CONVERT(NUMERIC(12,2),N.VRIMPOSUB)))), '.', ','),'0,00')       + '|' +
                                            '0'                                                                              + '|' +
                                            ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,SUM(CONVERT(NUMERIC(12,2),VRISENTRIB)))), '.', ','),'0,00')        + '|' +
                                            ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,SUM(CONVERT(NUMERIC(12,2),VROUTRCRED)))), '.', ','),'0,00')        + '|'  ) AS ARQ_E330

                                    FROM (SELECT SUM(CONVERT(NUMERIC(12,2),I.VRCONTABILNF)) AS VRCONTABILNF,
                                                 SUM(CASE I.CDFISCALNF WHEN '1' THEN CONVERT(NUMERIC(12,2),I.VRBASECALCNF) ELSE 0 END) AS VRBASECALCNF,
                                                 SUM(CASE I.CDFISCALNF WHEN '1' THEN CONVERT(NUMERIC(12,2),I.VRIMPOSTONF)  ELSE 0 END)  AS VRIMPOSTONF,
                                                 SUM(CASE I.CDFISCALNF WHEN '3' THEN CONVERT(NUMERIC(12,2),I.VRCONTABILNF) ELSE 0 END)   AS VROUTRCRED,
                                                 SUM(CASE I.CDFISCALNF WHEN '2' THEN CONVERT(NUMERIC(12,2),I.VRCONTABILNF) ELSE 0 END) AS VRISENTRIB,
                                                 SUM(CONVERT(NUMERIC(12,2),TEKNISA.VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, P.CDIMPOSTRIB, 'I', I.CDFISCALNF))) AS VRIMPOSUB

                                          FROM MAPAAPURAC M, NOTAFISCAL N, IMPOSTONF I, IMPOSTO P
                                          WHERE M.CDEMPRESA       = @P_CDEMPRESA           AND
                                                M.CDINSCESTA      = @P_CDINSCESTA          AND
                                                REPLACE(CONVERT(VARCHAR, M.DTINIPERIODO,103), '/', '') = @C300_DTINICIAL         AND
                                                REPLACE(CONVERT(VARCHAR, M.DTFIMPERIODO,103), '/', '') = @C300_DTFINAL           AND
                                                M.CDIMPOSTO       = @P_CDIMPOSTO           AND
                                                I.NRSEQUMAPAPU    = M.NRSEQUMAPAPU         AND
                                                I.CDIMPOSTO       = @P_CDIMPOSTO           AND
                                                I.CDIMPOSTO       = P.CDIMPOSTO            AND
                                                ISNULL(I.IDIMPOSTONF, '1') <> '3'          AND
                                                N.CDFILIAL        = I.CDFILIAL             AND
                                                N.NRLANCTONF      = I.NRLANCTONF           AND
                                                ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E')) AND
                                                N.CDMODDOCFISC    IN ('01','02','04','06','07','08','09','10','11','26','18','21','22','27','28')    AND
                                                N.IDENTRSAIDOP    = 'E'                    )N
                                    UNION ALL
                                    SELECT ('|E330'                                                                          + '|' +
                                            '5'                                                                              + '|' +
                                            ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,SUM(CONVERT(NUMERIC(12,2),N.VRCONTABILNF)))), '.', ','),'0,00')    + '|' +
                                            ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,SUM(CONVERT(NUMERIC(12,2),N.VRBASECALCNF)))), '.', ','),'0,00')    + '|' +
                                            ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,SUM(CONVERT(NUMERIC(12,2),N.VRIMPOSTONF)))), '.', ','),'0,00')     + '|' +
                                            ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,SUM(CONVERT(NUMERIC(12,2),N.VRIMPOSUB)))), '.', ','),'0,00')       + '|' +
                                            '0'                                                                              + '|' +
                                            ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,SUM(CONVERT(NUMERIC(12,2),VRISENTRIB)))), '.', ','),'0,00')        + '|' +
                                            ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,SUM(CONVERT(NUMERIC(12,2),VROUTRCRED)))), '.', ','),'0,00')        + '|'  ) AS ARQ_E330

                                    FROM (SELECT SUM(CONVERT(NUMERIC(12,2),I.VRCONTABILNF)) AS VRCONTABILNF,
                                                 SUM(CASE I.CDFISCALNF WHEN '1' THEN CONVERT(NUMERIC(12,2),I.VRBASECALCNF) ELSE 0 END) AS VRBASECALCNF,
                                                 SUM(CASE I.CDFISCALNF WHEN '1' THEN CONVERT(NUMERIC(12,2),I.VRIMPOSTONF)  ELSE 0 END)  AS VRIMPOSTONF,
                                                 SUM(CASE I.CDFISCALNF WHEN '3' THEN CONVERT(NUMERIC(12,2),I.VRCONTABILNF) ELSE 0 END)   AS VROUTRCRED,
                                                 SUM(CASE I.CDFISCALNF WHEN '2' THEN CONVERT(NUMERIC(12,2),I.VRCONTABILNF) ELSE 0 END) AS VRISENTRIB,
                                                 SUM(CONVERT(NUMERIC(12,2),TEKNISA.VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, P.CDIMPOSTRIB, 'I', I.CDFISCALNF))) AS VRIMPOSUB,
                                                 SUM(CASE I.CDFISCALNF WHEN '1' THEN CONVERT(NUMERIC(12,2),I.VRIMPOSTONF) ELSE 0 END) AS VRTOTIMPOSNF,
                                                 0 AS VRTOTENTR,
                                                 0 AS VRTOTOUTRCRED
                                          FROM MAPAAPURAC M, NOTAFISCAL N, IMPOSTONF I, IMPOSTO P
                                          WHERE M.CDEMPRESA       = @P_CDEMPRESA           AND
                                                M.CDINSCESTA      = @P_CDINSCESTA          AND
                                                REPLACE(CONVERT(VARCHAR, M.DTINIPERIODO,103), '/', '') = @C300_DTINICIAL         AND
                                                REPLACE(CONVERT(VARCHAR, M.DTFIMPERIODO,103), '/', '') = @C300_DTFINAL           AND
                                                M.CDIMPOSTO       = @P_CDIMPOSTO           AND
                                                I.NRSEQUMAPAPU    = M.NRSEQUMAPAPU         AND
                                                I.CDIMPOSTO       = @P_CDIMPOSTO           AND
                                                I.CDIMPOSTO       = P.CDIMPOSTO            AND
                                                ISNULL(I.IDIMPOSTONF, '1') <> '3'          AND
                                                SUBSTRING(I.CDFISCOPERNF,1,1) = '5'        AND
                                                N.CDFILIAL        = I.CDFILIAL             AND
                                                N.NRLANCTONF      = I.NRLANCTONF           AND
                                                N.CDSERIE         <> 'ECF'                 AND
                                                N.IDENTRSAIDOP    = 'S'                    AND
                                                N.CDMODDOCFISC    IN ('01','02','04','06','07','08','09','10','11','26','18','21','22','27','28')    AND
                                                ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E'))
                                          UNION ALL

                                          SELECT SUM(CONVERT(NUMERIC(12,2),I.VRCONTABILNF)) AS VRCONTABILNF,
                                                 SUM(CASE I.CDFISCALNF WHEN '1' THEN CONVERT(NUMERIC(12,2),I.VRBASECALCNF) ELSE 0 END) AS VRBASECALCNF,
                                                 SUM(CASE I.CDFISCALNF WHEN '1' THEN CONVERT(NUMERIC(12,2),I.VRIMPOSTONF)  ELSE 0 END) AS VRIMPOSTONF,
                                                 0 AS VROUTRCRED,
                                                 SUM(CASE I.CDFISCALNF WHEN '2' THEN CONVERT(NUMERIC(12,2),I.VRCONTABILNF) ELSE 0 END) AS VRISENTRIB,
                                                 SUM(CONVERT(NUMERIC(12,2),TEKNISA.VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, P.CDIMPOSTRIB, 'I', I.CDFISCALNF))) AS VRIMPOSUB,
                                                 SUM(CASE I.CDFISCALNF WHEN '1' THEN CONVERT(NUMERIC(12,2),I.VRIMPOSTONF) ELSE  0 END) AS VRTOTIMPOSNF,
                                                 0 AS VRTOTENTR,
                                                 0 AS VRTOTOUTRCRED
                                          FROM MAPAAPURAC M, NOTAFISCAL N, IMPOSTONF I, IMPOSTO P
                                          WHERE M.CDEMPRESA       = @P_CDEMPRESA           AND
                                                M.CDINSCESTA      = @P_CDINSCESTA          AND
                                                REPLACE(CONVERT(VARCHAR, M.DTINIPERIODO,103), '/', '') = @C300_DTINICIAL         AND
                                                REPLACE(CONVERT(VARCHAR, M.DTFIMPERIODO,103), '/', '') = @C300_DTFINAL           AND
                                                M.CDIMPOSTO       = @P_CDIMPOSTO           AND
                                                I.NRSEQUMAPAPU    = M.NRSEQUMAPAPU         AND
                                                I.CDIMPOSTO       = @P_CDIMPOSTO           AND
                                                I.CDIMPOSTO       = P.CDIMPOSTO            AND
                                                ISNULL(I.IDIMPOSTONF, '1') <> '3'          AND
                                                SUBSTRING(I.CDFISCOPERNF,1,1) = '5'        AND
                                                N.CDFILIAL        = I.CDFILIAL             AND
                                                N.NRLANCTONF      = I.NRLANCTONF           AND
                                                N.CDSERIE         = 'ECF'                  AND
                                                N.IDENTRSAIDOP    = 'S'                    AND
                                                ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E')) )N
                                    UNION
                                    SELECT ('|E330'                                                                        + '|' +
                                            '6'                                                                            + '|' +
                                            ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,SUM(CONVERT(NUMERIC(12,2),N.VRCONTABILNF)))), '.', ','),'0,00')  + '|' +
                                            ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,SUM(CONVERT(NUMERIC(12,2),N.VRBASECALCNF)))), '.', ','),'0,00')  + '|' +
                                            ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,SUM(CONVERT(NUMERIC(12,2),N.VRIMPOSTONF)))), '.', ','),'0,00')   + '|' +
                                            ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,SUM(CONVERT(NUMERIC(12,2),N.VRIMPOSUB)))), '.', ','),'0,00')     + '|' +
                                            '0'                                                                            + '|' +
                                            ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,SUM(CONVERT(NUMERIC(12,2),VRISENTRIB)))), '.', ','),'0,00')      + '|' +
                                            ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,SUM(CONVERT(NUMERIC(12,2),VROUTRCRED)))), '.', ','),'0,00')      + '|'  ) AS ARQ_E330

                                    FROM (SELECT SUM(CONVERT(NUMERIC(12,2),I.VRCONTABILNF)) AS VRCONTABILNF,
                                                 SUM(CASE I.CDFISCALNF WHEN '1' THEN CONVERT(NUMERIC(12,2),I.VRBASECALCNF) ELSE 0 END) AS VRBASECALCNF,
                                                 SUM(CASE I.CDFISCALNF WHEN '1' THEN CONVERT(NUMERIC(12,2),I.VRIMPOSTONF)  ELSE 0 END)  AS VRIMPOSTONF,
                                                 SUM(CASE I.CDFISCALNF WHEN '3' THEN CONVERT(NUMERIC(12,2),I.VRCONTABILNF) ELSE 0 END)   AS VROUTRCRED,
                                                 SUM(CASE I.CDFISCALNF WHEN '2' THEN CONVERT(NUMERIC(12,2),I.VRCONTABILNF) ELSE 0 END) AS VRISENTRIB,
                                                 SUM(CONVERT(NUMERIC(12,2),TEKNISA.VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, P.CDIMPOSTRIB, 'I', I.CDFISCALNF))) AS VRIMPOSUB,
                                                 SUM(CASE I.CDFISCALNF WHEN '1' THEN CONVERT(NUMERIC(12,2),I.VRIMPOSTONF) ELSE 0 END)  AS VRTOTIMPOSNF,
                                                 0 AS VRTOTENTR,
                                                 0 AS VRTOTOUTRCRED
                                          FROM MAPAAPURAC M, NOTAFISCAL N, IMPOSTONF I, IMPOSTO P
                                          WHERE M.CDEMPRESA       = @P_CDEMPRESA           AND
                                                M.CDINSCESTA      = @P_CDINSCESTA          AND
                                                REPLACE(CONVERT(VARCHAR, M.DTINIPERIODO,103), '/', '') = @C300_DTINICIAL         AND
                                                REPLACE(CONVERT(VARCHAR, M.DTFIMPERIODO,103), '/', '') = @C300_DTFINAL           AND
                                                M.CDIMPOSTO       = @P_CDIMPOSTO           AND
                                                I.NRSEQUMAPAPU    = M.NRSEQUMAPAPU         AND
                                                I.CDIMPOSTO       = @P_CDIMPOSTO           AND
                                                I.CDIMPOSTO       = P.CDIMPOSTO            AND
                                                ISNULL(I.IDIMPOSTONF, '1') <> '3'          AND
                                                SUBSTRING(I.CDFISCOPERNF,1,1) = '6'        AND
                                                N.CDFILIAL        = I.CDFILIAL             AND
                                                N.NRLANCTONF      = I.NRLANCTONF           AND
                                                N.CDSERIE         <> 'ECF'                 AND
                                                N.IDENTRSAIDOP    = 'S'                    AND
                                                N.CDMODDOCFISC    IN ('01','02','04','06','07','08','09','10','11','26','18','21','22','27','28')    AND
                                                ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E'))
                                          UNION ALL
                                          SELECT SUM(CONVERT(NUMERIC(12,2),I.VRCONTABILNF)) AS VRCONTABILNF,
                                                 SUM(CASE I.CDFISCALNF WHEN '1' THEN CONVERT(NUMERIC(12,2),I.VRBASECALCNF) ELSE 0 END) AS VRBASECALCNF,
                                                 SUM(CASE I.CDFISCALNF WHEN '1' THEN CONVERT(NUMERIC(12,2),I.VRIMPOSTONF)  ELSE 0 END)  AS VRIMPOSTONF,
                                                 0 AS VROUTRCRED,
                                                 SUM(CASE I.CDFISCALNF WHEN '2' THEN CONVERT(NUMERIC(12,2),I.VRCONTABILNF) ELSE 0 END) AS VRISENTRIB,
                                                 SUM(CONVERT(NUMERIC(12,2),TEKNISA.VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, P.CDIMPOSTRIB, 'I', I.CDFISCALNF))) AS VRIMPOSUB,
                                                 SUM(CASE I.CDFISCALNF WHEN '1' THEN CONVERT(NUMERIC(12,2),I.VRIMPOSTONF) ELSE 0 END)  AS VRTOTIMPOSNF,
                                                 0 AS VRTOTENTR,
                                                 0 AS VRTOTOUTRCRED
                                          FROM MAPAAPURAC M, NOTAFISCAL N, IMPOSTONF I, IMPOSTO P
                                          WHERE M.CDEMPRESA       = @P_CDEMPRESA           AND
                                                M.CDINSCESTA      = @P_CDINSCESTA          AND
                                                REPLACE(CONVERT(VARCHAR, M.DTINIPERIODO,103), '/', '') = @C300_DTINICIAL         AND
                                                REPLACE(CONVERT(VARCHAR, M.DTFIMPERIODO,103), '/', '') = @C300_DTFINAL           AND
                                                M.CDIMPOSTO       = @P_CDIMPOSTO           AND
                                                I.NRSEQUMAPAPU    = M.NRSEQUMAPAPU         AND
                                                I.CDIMPOSTO       = @P_CDIMPOSTO           AND
                                                I.CDIMPOSTO       = P.CDIMPOSTO            AND
                                                ISNULL(I.IDIMPOSTONF, '1') <> '3'          AND
                                                SUBSTRING(I.CDFISCOPERNF,1,1) = '6'        AND
                                                N.CDFILIAL        = I.CDFILIAL             AND
                                                N.NRLANCTONF      = I.NRLANCTONF           AND
                                                N.CDSERIE         = 'ECF'                  AND
                                                N.IDENTRSAIDOP    = 'S'                    AND
                                                ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E')))N
                                    UNION ALL
                                    SELECT ('|E330'                  + '|' +
                                            '7'                      + '|' +
                                            ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,SUM(CONVERT(NUMERIC(12,2),N.VRCONTABILNF)))), '.', ','),'0,00')    + '|' +
                                            ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,SUM(CONVERT(NUMERIC(12,2),N.VRBASECALCNF)))), '.', ','),'0,00')    + '|' +
                                            ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,SUM(CONVERT(NUMERIC(12,2),N.VRIMPOSTONF)))), '.', ','),'0,00')    + '|' +
                                            ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,SUM(CONVERT(NUMERIC(12,2),N.VRIMPOSUB)))), '.', ','),'0,00')    + '|' +
                                            '0'                      + '|' +
                                            ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,SUM(CONVERT(NUMERIC(12,2),VRISENTRIB)))), '.', ','),'0,00')    + '|' +
                                            ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,SUM(CONVERT(NUMERIC(12,2),VROUTRCRED)))), '.', ','),'0,00')    + '|'  ) AS ARQ_E330
                                    FROM (SELECT SUM(CONVERT(NUMERIC(12,2),I.VRCONTABILNF)) AS VRCONTABILNF,
                                                 SUM(CASE I.CDFISCALNF WHEN '1' THEN CONVERT(NUMERIC(12,2),I.VRBASECALCNF) ELSE 0 END) AS VRBASECALCNF,
                                                 SUM(CASE I.CDFISCALNF WHEN '1' THEN CONVERT(NUMERIC(12,2),I.VRIMPOSTONF)  ELSE 0 END)  AS VRIMPOSTONF,
                                                 SUM(CASE I.CDFISCALNF WHEN '3' THEN CONVERT(NUMERIC(12,2),I.VRCONTABILNF) ELSE 0 END)   AS VROUTRCRED,
                                                 SUM(CASE I.CDFISCALNF WHEN '2' THEN CONVERT(NUMERIC(12,2),I.VRCONTABILNF) ELSE 0 END) AS VRISENTRIB,
                                                 SUM(CONVERT(NUMERIC(12,2),TEKNISA.VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, P.CDIMPOSTRIB, 'I', I.CDFISCALNF))) AS VRIMPOSUB,
                                                 SUM(CASE I.CDFISCALNF WHEN '1' THEN CONVERT(NUMERIC(12,2),I.VRIMPOSTONF)  ELSE 0 END) AS VRTOTIMPOSNF,
                                                 0 AS VRTOTENTR,
                                                 0 AS VRTOTOUTRCRED
                                          FROM MAPAAPURAC M, NOTAFISCAL N, IMPOSTONF I, IMPOSTO P
                                          WHERE M.CDEMPRESA       = @P_CDEMPRESA           AND
                                                M.CDINSCESTA      = @P_CDINSCESTA          AND
                                                REPLACE(CONVERT(VARCHAR, M.DTINIPERIODO,103), '/', '') = @C300_DTINICIAL         AND
                                                REPLACE(CONVERT(VARCHAR, M.DTFIMPERIODO,103), '/', '') = @C300_DTFINAL           AND
                                                M.CDIMPOSTO       = @P_CDIMPOSTO           AND
                                                I.NRSEQUMAPAPU    = M.NRSEQUMAPAPU         AND
                                                I.CDIMPOSTO       = @P_CDIMPOSTO           AND
                                                I.CDIMPOSTO       = P.CDIMPOSTO            AND
                                                ISNULL(I.IDIMPOSTONF, '1') <> '3'          AND
                                                SUBSTRING(I.CDFISCOPERNF,1,1) = '7'        AND
                                                N.CDFILIAL        = I.CDFILIAL             AND
                                                N.NRLANCTONF      = I.NRLANCTONF           AND
                                                N.CDSERIE         <> 'ECF'                 AND
                                                N.IDENTRSAIDOP    = 'S'                    AND
                                                N.CDMODDOCFISC    IN ('01','02','04','06','07','08','09','10','11','26','18','21','22','27','28')    AND
                                                ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E'))
                                          UNION ALL
                                          SELECT SUM(CONVERT(NUMERIC(12,2),I.VRCONTABILNF)) AS VRCONTABILNF,
                                                 SUM(CASE I.CDFISCALNF WHEN '1' THEN CONVERT(NUMERIC(12,2),I.VRBASECALCNF) ELSE 0 END) AS VRBASECALCNF,
                                                 SUM(CASE I.CDFISCALNF WHEN '1' THEN CONVERT(NUMERIC(12,2),I.VRIMPOSTONF)  ELSE 0 END)  AS VRIMPOSTONF,
                                                 0 AS VROUTRCRED,
                                                 SUM(CASE I.CDFISCALNF WHEN '2' THEN CONVERT(NUMERIC(12,2),I.VRCONTABILNF) ELSE 0 END) AS VRISENTRIB,
                                                 SUM(CONVERT(NUMERIC(12,2),TEKNISA.VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, P.CDIMPOSTRIB, 'I', I.CDFISCALNF))) AS VRIMPOSUB,
                                                 SUM(CASE I.CDFISCALNF WHEN '1' THEN CONVERT(NUMERIC(12,2),I.VRIMPOSTONF)  ELSE 0 END) AS VRTOTIMPOSNF,
                                                 0 AS VRTOTENTR,
                                                 0 AS VRTOTOUTRCRED
                                          FROM MAPAAPURAC M, NOTAFISCAL N, IMPOSTONF I, IMPOSTO P
                                          WHERE M.CDEMPRESA       = @P_CDEMPRESA            AND
                                                M.CDINSCESTA      = @P_CDINSCESTA           AND
                                                REPLACE(CONVERT(VARCHAR, M.DTINIPERIODO,103), '/', '') = @C300_DTINICIAL         AND
                                                REPLACE(CONVERT(VARCHAR, M.DTFIMPERIODO,103), '/', '') = @C300_DTFINAL           AND
                                                M.CDIMPOSTO       = @P_CDIMPOSTO            AND
                                                I.NRSEQUMAPAPU    = M.NRSEQUMAPAPU          AND
                                                I.CDIMPOSTO       = @P_CDIMPOSTO            AND
                                                I.CDIMPOSTO       = P.CDIMPOSTO             AND
                                                ISNULL(I.IDIMPOSTONF, '1') <> '3'           AND
                                                SUBSTRING(I.CDFISCOPERNF,1,1) = '7'         AND
                                                N.CDFILIAL        = I.CDFILIAL              AND
                                                N.NRLANCTONF      = I.NRLANCTONF            AND
                                                N.CDSERIE         = 'ECF'                   AND
                                                N.IDENTRSAIDOP    = 'S'                     AND
                                                ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E')) )N
                                    UNION
                                    SELECT ('|E330'                  + '|' +
                                            '8'                      + '|' +
                                            ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,SUM(CONVERT(NUMERIC(12,2),N.VRCONTABILNF)))), '.', ','),'0,00')   + '|' +
                                            ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,SUM(CONVERT(NUMERIC(12,2),N.VRBASECALCNF)))), '.', ','),'0,00')   + '|' +
                                            ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,SUM(CONVERT(NUMERIC(12,2),N.VRIMPOSTONF)))), '.', ','),'0,00')    + '|' +
                                            ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,SUM(CONVERT(NUMERIC(12,2),N.VRIMPOSUB)))), '.', ','),'0,00')      + '|' +
                                            '0'                                                                             + '|' +
                                            ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,SUM(CONVERT(NUMERIC(12,2),VRISENTRIB)))), '.', ','),'0,00')       + '|' +
                                            ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,SUM(CONVERT(NUMERIC(12,2),VROUTRCRED)))), '.', ','),'0,00')       + '|'  ) AS ARQ_E330

                                    FROM (SELECT SUM(CONVERT(NUMERIC(12,2),I.VRCONTABILNF)) AS VRCONTABILNF,
                                                 SUM(CASE I.CDFISCALNF WHEN '1' THEN CONVERT(NUMERIC(12,2),I.VRBASECALCNF) ELSE 0 END) AS VRBASECALCNF,
                                                 SUM(CASE I.CDFISCALNF WHEN '1' THEN CONVERT(NUMERIC(12,2),I.VRIMPOSTONF)  ELSE 0 END)  AS VRIMPOSTONF,
                                                 SUM(CASE I.CDFISCALNF WHEN '3' THEN CONVERT(NUMERIC(12,2),I.VRCONTABILNF) ELSE 0 END)   AS VROUTRCRED,
                                                 SUM(CASE I.CDFISCALNF WHEN '2' THEN CONVERT(NUMERIC(12,2),I.VRCONTABILNF) ELSE 0 END) AS VRISENTRIB,
                                                 SUM(CONVERT(NUMERIC(12,2),TEKNISA.VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, P.CDIMPOSTRIB, 'I', I.CDFISCALNF))) AS VRIMPOSUB,
                                                 0 AS VRTOTIMPOSNF,
                                                 0 AS VRTOTENTR,
                                                 SUM(CASE I.CDFISCALNF WHEN '3' THEN CONVERT(NUMERIC(12,2),I.VRCONTABILNF) ELSE 0 END)  AS VRTOTOUTRCRED
                                          FROM MAPAAPURAC M, NOTAFISCAL N, IMPOSTONF I, IMPOSTO P
                                          WHERE M.CDEMPRESA       = @P_CDEMPRESA            AND
                                                M.CDINSCESTA      = @P_CDINSCESTA           AND
                                                REPLACE(CONVERT(VARCHAR, M.DTINIPERIODO,103), '/', '') = @C300_DTINICIAL         AND
                                                REPLACE(CONVERT(VARCHAR, M.DTFIMPERIODO,103), '/', '') = @C300_DTFINAL           AND
                                                M.CDIMPOSTO       = @P_CDIMPOSTO            AND
                                                I.NRSEQUMAPAPU    = M.NRSEQUMAPAPU          AND
                                                I.CDIMPOSTO       = @P_CDIMPOSTO            AND
                                                I.CDIMPOSTO       = P.CDIMPOSTO             AND
                                                ISNULL(I.IDIMPOSTONF, '1') <> '3'           AND
                                                N.CDFILIAL        = I.CDFILIAL              AND
                                                N.NRLANCTONF      = I.NRLANCTONF            AND
                                                N.CDSERIE         <> 'ECF'                  AND
                                                N.IDENTRSAIDOP    = 'S'                     AND
                                                N.CDMODDOCFISC    IN ('01','02','04','06','07','08','09','10','11','26','18','21','22','27','28')    AND
                                                ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E'))
                                          UNION ALL

                                          SELECT SUM(CONVERT(NUMERIC(12,2),I.VRCONTABILNF)) AS VRCONTABILNF,
                                                 SUM(CASE I.CDFISCALNF WHEN '1' THEN CONVERT(NUMERIC(12,2),I.VRBASECALCNF) ELSE 0 END) AS VRBASECALCNF,
                                                 SUM(CASE I.CDFISCALNF WHEN '1' THEN CONVERT(NUMERIC(12,2),I.VRIMPOSTONF)  ELSE 0 END)  AS VRIMPOSTONF,
                                                 0 AS VROUTRCRED,
                                                 SUM(CASE I.CDFISCALNF WHEN '2' THEN CONVERT(NUMERIC(12,2),I.VRCONTABILNF) ELSE 0 END) AS VRISENTRIB,
                                                 SUM(CONVERT(NUMERIC(12,2),TEKNISA.VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, P.CDIMPOSTRIB, 'I', I.CDFISCALNF))) AS VRIMPOSUB,
                                                 0 AS VRTOTIMPOSNF,
                                                 0 AS VRTOTENTR,
                                                 SUM(CASE I.CDFISCALNF WHEN '3' THEN CONVERT(NUMERIC(12,2),I.VRCONTABILNF) ELSE 0 END)  AS VRTOTOUTRCRED
                                          FROM MAPAAPURAC M, NOTAFISCAL N, IMPOSTONF I, IMPOSTO P
                                          WHERE M.CDEMPRESA       = @P_CDEMPRESA            AND
                                                M.CDINSCESTA      = @P_CDINSCESTA           AND
                                                REPLACE(CONVERT(VARCHAR, M.DTINIPERIODO,103), '/', '') = @C300_DTINICIAL         AND
                                                REPLACE(CONVERT(VARCHAR, M.DTFIMPERIODO,103), '/', '') = @C300_DTFINAL           AND
                                                M.CDIMPOSTO       = @P_CDIMPOSTO            AND
                                                I.NRSEQUMAPAPU    = M.NRSEQUMAPAPU          AND
                                                I.CDIMPOSTO       = @P_CDIMPOSTO            AND
                                                I.CDIMPOSTO       = P.CDIMPOSTO             AND
                                                ISNULL(I.IDIMPOSTONF, '1') <> '3'           AND
                                                N.CDFILIAL        = I.CDFILIAL              AND
                                                N.NRLANCTONF      = I.NRLANCTONF            AND
                                                N.CDSERIE         = 'ECF'                   AND
                                                N.IDENTRSAIDOP    = 'S'                     AND
                                                ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E')) )N )
     OPEN C_REGE330;

     FETCH NEXT FROM C_REGE330 INTO @C_ARQ_E330;

     WHILE (@@FETCH_STATUS = 0) BEGIN

         INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           ('38'+RIGHT(REPLICATE('0',8)+RTRIM(@V_CONTREGE), 8), @C_ARQ_E330, @P_NRSEQARQMAG);
         SET @V_CONTREGE =  ISNULL(@V_CONTREGE,0) + 1;
      
         FETCH NEXT FROM C_REGE330 INTO @C_ARQ_E330;

      END;
      CLOSE C_REGE330;
      DEALLOCATE C_REGE330;

      /* REGISTRO E340 */
      DECLARE C_REGE340 CURSOR FOR (SELECT /* 01 */ ('|E340'           + '|' +
                                           /* 02 */  ISNULL(IR.NRSEQITMAPR, '')    + '|' +
                                           /* 03 */  ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,SUM(CONVERT(NUMERIC(12,2),IR.VRITEMMAPR)))), '.', ','),'0,00')   + '|' +
                                           /* 04 */  ''   + '|' +
                                           /* 05 */  ''   + '|' +
                                           /* 06 */  '0'  + '|' +
                                           /* 07 */  ''   + '|' +
                                           /* 08 */  ''   + '|' ) AS ARQ_E340
                                    FROM MAPAAPURAC M, ITMAPARECUP IR
                                    WHERE M.CDEMPRESA       = @P_CDEMPRESA            AND
                                          M.CDINSCESTA      = @P_CDINSCESTA           AND
                                          M.DTINIPERIODO    = @P_DTINICIAL            AND
                                          M.DTFIMPERIODO    = @P_DTFINAL              AND
                                          M.CDIMPOSTO       = @P_CDIMPOSTO            AND
                                          M.NRSEQUMAPAPU    = IR.NRSEQUMAPAPU
                                    GROUP BY IR.NRSEQITMAPR)
     OPEN C_REGE340;
 
     FETCH NEXT FROM C_REGE340 INTO @C_ARQ_E340;

     WHILE (@@FETCH_STATUS = 0) BEGIN  

         INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           ('39'+RIGHT(REPLICATE('0',8)+RTRIM(@V_CONTREGE), 8), @C_ARQ_E340, @P_NRSEQARQMAG);
         SET @V_CONTREGE =  ISNULL(@V_CONTREGE,0) + 1;
      
         FETCH NEXT FROM C_REGE340 INTO @C_ARQ_E340;

      END;
      CLOSE C_REGE340;
      DEALLOCATE C_REGE340;

      DECLARE C_REGE350 CURSOR FOR (SELECT /* 01 */  ('|E350'   + '|' +
                                           /* 02 */   '000'   + '|' +
                                           /* 03 */   ISNULL(REPLACE(LTRIM(CONVERT(VARCHAR,CONVERT(NUMERIC(12,2),VRTOTAGUIA))), '.', ','),'0,00')   + '|' +
                                           /* 04 */   ISNULL(REPLACE(CONVERT(VARCHAR,DTVENCGUIA,103), '/', ''), '')    + '|' +
                                           /* 05 */   ISNULL(CDRECEGUIA, '')   + '|' +
                                           /* 06 */   ''           + '|' +
                                           /* 07 */   ''           + '|' +
                                           /* 08 */   '0'          + '|' +
                                           /* 09 */   ''           + '|' +
                                           /* 10 */   ''           + '|'  ) AS ARQ_E350
                                    FROM MAPAAPURAC M, INSCRESTAD I
                                    WHERE M.CDEMPRESA     = @P_CDEMPRESA      AND
                                          M.CDINSCESTA    = @P_CDINSCESTA     AND
                                          M.DTINIPERIODO  = @P_DTINICIAL      AND
                                          M.DTFIMPERIODO  = @P_DTFINAL        AND
                                          M.CDIMPOSTO     = @P_CDIMPOSTO      AND
                                          M.CDEMPRESA     = I.CDEMPRESA       AND
                                          M.CDINSCESTA    = I.CDINSCESTA      AND
                                          M.DTVENCGUIA IS NOT NULL            AND
                                          M.VRTOTAGUIA > 0)
     OPEN C_REGE350;
 
     FETCH NEXT FROM C_REGE350 INTO @C_ARQ_E350;

     WHILE (@@FETCH_STATUS = 0) BEGIN  

         INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           ('40'+RIGHT(REPLICATE('0',8)+RTRIM(@V_CONTREGE), 8), @C_ARQ_E350, @P_NRSEQARQMAG);
         SET @V_CONTREGE =  ISNULL(@V_CONTREGE,0) + 1;
      
         FETCH NEXT FROM C_REGE350 INTO @C_ARQ_E350;

      END;
      CLOSE C_REGE350; 
      DEALLOCATE C_REGE350;

      DECLARE C_REGE360 CURSOR FOR (SELECT ('|E360'         + '|' +
                            /* campo 01 */  REPLACE(LTRIM(CONVERT(VARCHAR,ISNULL(CONVERT(NUMERIC(12,2), ABS(N.VRNORMDEBI)),0))), '.', ',')    + '|' +     /* debitos por sada */
                            /* campo 02 */  REPLACE(LTRIM(CONVERT(VARCHAR,ISNULL(CONVERT(NUMERIC(12,2), ABS(N.VROUTRDEBI)),0))), '.', ',')    + '|' +     /* outros debitos */
                            /* campo 03 */  REPLACE(LTRIM(CONVERT(VARCHAR,ISNULL(CONVERT(NUMERIC(12,2), ABS(N.VRESTOCRED)),0))), '.', ',')    + '|' +     /* estornos de crdito */
                            /* campo 04 */  REPLACE(LTRIM(CONVERT(VARCHAR,ISNULL(CONVERT(NUMERIC(12,2), ABS(N.VRTOTDEB)),0))), '.', ',')    + '|' +       /* valor total de debitos 01+02+03 */
                            /* campo 05 */  REPLACE(LTRIM(CONVERT(VARCHAR,ISNULL(CONVERT(NUMERIC(12,2), ABS(N.VRNORMCRED)),0))), '.', ',')    + '|' +   /* valor total de entradas CFIOP's 1,2,3 */
                            /* campo 06 */  REPLACE(LTRIM(CONVERT(VARCHAR,ISNULL(CONVERT(NUMERIC(12,2), ABS(N.VROUTRCRED)),0))), '.', ',')    + '|' +     /* valor total de outros creditos */
                            /* campo 07 */  REPLACE(LTRIM(CONVERT(VARCHAR,ISNULL(CONVERT(NUMERIC(12,2), ABS(N.VRESTODEBI)),0))), '.', ',')    + '|' +     /* valor total de estornos de dbito */
                            /* campo 08 */  REPLACE(LTRIM(CONVERT(VARCHAR,ISNULL(CONVERT(NUMERIC(12,2), ABS(N.VRSUBTOTCRED)),0))), '.', ',')    + '|' +   /* sub total de crditos (05+06+07)  */
                            /* campo 09 */  REPLACE(LTRIM(CONVERT(VARCHAR,ISNULL(CONVERT(NUMERIC(12,2), ABS(N.VRSLDCRANTE)),0))), '.', ',')    + '|' +    /* saldo credor do periodo anterior */
                            /* campo 10 */  REPLACE(LTRIM(CONVERT(VARCHAR,ISNULL(CONVERT(NUMERIC(12,2), ABS(N.VRSUBTOTCRED+N.VRSLDCRANTE)),0))), '.', ',')    + '|' +  /* valor total do creditos (08+09) */
			    /* campo 11 */  REPLACE(LTRIM(CONVERT(VARCHAR,ISNULL(CONVERT(NUMERIC(12,2), ABS(CASE (N.VRSUBTOTCRED+N.VRSLDCRANTE) - N.VRTOTDEB WHEN ABS(N.VRSUBTOTCRED+N.VRSLDCRANTE) - N.VRTOTDEB THEN (N.VRSUBTOTCRED+N.VRSLDCRANTE) - N.VRTOTDEB ELSE 0 END)),0))), '.', ',')    + '|' +     /*  valor total saldo credor a transportar para o periodo seguinte (10-04) */
                            /* campo 12 */  REPLACE(LTRIM(CONVERT(VARCHAR,ISNULL(CONVERT(NUMERIC(12,2), ABS((N.VRTOTDEB- (N.VRSUBTOTCRED+N.VRSLDCRANTE)))),0))), '.', ',')    + '|' +       /* valor total saldo devedor (04-10) */
                            /* campo 13 */  REPLACE(LTRIM(CONVERT(VARCHAR,ISNULL(CONVERT(NUMERIC(12,2), ABS(N.VRDEDUCAO)),0))), '.', ',')    + '|' +        /* valor total de dedues */
                            /* campo 14 */  REPLACE(LTRIM(CONVERT(VARCHAR,ISNULL(CONVERT(NUMERIC(12,2), ABS(N.VRICMSRECOLHE)),0))), '.', ',')    + '|' +        /* icms a recolher (12-13) */
                            /* campo 15 */  '0'             + '|' +  /* icms substituto pela entrada */
                            /* campo 16 */  '0'             + '|' +  /* icms substituto pelas sadas para o Estado */
                            /* campo 17 */  REPLACE(LTRIM(CONVERT(VARCHAR,ISNULL(CONVERT( NUMERIC(12,2), ABS(N.VRDIFALIQU)),0))), '.', ',')    + '|' + /* valor total diferencial de alquota */
                            /* campo 18 */  '0'             + '|' +  /* valor total de icms da importao */
                            /* campo 19 */  '0'             + '|' +  /* valor total de outras obrigaes do icms */
                            /* campo 20 */  REPLACE(LTRIM(CONVERT(VARCHAR,ISNULL(CONVERT( NUMERIC(12,2), ABS(N.VRTOTAIMPOS)),0))), '.', ',')    + '|' +   /* valor total das obrigaes do icms a recolher*/
                            /* campo 99 */  '0'             + '|'  ) AS ARQ_E360
                                    FROM (SELECT CONVERT(NUMERIC(12,2),R.VRNORMDEBI) AS VRNORMDEBI,
                                                 CONVERT(NUMERIC(12,2),R.VROUTRDEBI) AS VROUTRDEBI,
                                                 CONVERT(NUMERIC(12,2),R.VRESTOCRED) AS VRESTOCRED,
                                                 CONVERT(NUMERIC(12,2),R.VRNORMDEBI+R.VROUTRDEBI+R.VRESTOCRED) AS VRTOTDEB,
                                                 (R.VRNORMDEBI+R.VROUTRDEBI+R.VRESTOCRED) - (R.VRNORMCRED+R.VROUTRCRED+R.VRESTODEBI+VRSLDCRANTE) - R.VRDEDUCAO AS VRICMSRECOLHE,
                                                 CONVERT(NUMERIC(12,2),R.VRNORMCRED) AS VRNORMCRED,
                                                 CONVERT(NUMERIC(12,2),R.VROUTRCRED) AS VROUTRCRED,
                                                 CONVERT(NUMERIC(12,2),R.VRESTODEBI) AS VRESTODEBI,
                                                 CONVERT(NUMERIC(12,2),R.VRNORMCRED+R.VROUTRCRED+R.VRESTODEBI) AS VRSUBCRED,
                                                 CONVERT(NUMERIC(12,2),R.VRSLDCRANTE) AS VRSLDCRANTE,
                                                 CONVERT(NUMERIC(12,2),R.VRNORMCRED+R.VROUTRCRED+R.VRESTODEBI+VRSLDCRANTE) AS VRTOTCRED,
                                                 CONVERT(NUMERIC(12,2),ABS((R.VRNORMCRED+R.VROUTRCRED+R.VRESTODEBI+VRSLDCRANTE) - (R.VRNORMDEBI+R.VROUTRDEBI+R.VRESTOCRED))) AS SALDCRED,
                                                 CONVERT(NUMERIC(12,2),(R.VRNORMDEBI+R.VROUTRDEBI+R.VRESTOCRED) - (R.VRNORMCRED+R.VROUTRCRED+R.VRESTODEBI+VRSLDCRANTE)) AS SALDDEVE,
                                                 CONVERT(NUMERIC(12,2),R.VRSALDODEBI) AS VRSALDODEBI,
                                                 CONVERT(NUMERIC(12,2),(R.VRNORMDEBI+R.VROUTRDEBI+R.VRESTOCRED) - (R.VRNORMCRED+R.VROUTRCRED+R.VRESTODEBI+VRSLDCRANTE) - R.VRDEDUCAO) AS ICMSRECO,
                                                 CONVERT(NUMERIC(12,2),R.VRDIFALIQU) AS VRDIFALIQU,
                                                 CONVERT(NUMERIC(12,2),M.VRTOTAIMPOS) AS VRTOTAIMPOS,
                                                 R.VRDEDUCAO AS VRDEDUCAO,
                                                 (R.VRNORMCRED+R.VROUTRCRED+R.VRESTODEBI) AS VRSUBTOTCRED
                                          FROM MAPAAPURAC M, MAPARECUP R
                                          WHERE M.CDEMPRESA       = @P_CDEMPRESA            AND
                                                M.CDINSCESTA      = @P_CDINSCESTA           AND
                                                REPLACE(CONVERT(VARCHAR, M.DTINIPERIODO,103), '/', '') = @C300_DTINICIAL         AND
                                                REPLACE(CONVERT(VARCHAR, M.DTFIMPERIODO,103), '/', '') = @C300_DTFINAL           AND
                                                M.CDIMPOSTO       = @P_CDIMPOSTO            AND
                                                R.NRSEQUMAPAPU    = M.NRSEQUMAPAPU ) N )
     OPEN C_REGE360;

     FETCH NEXT FROM C_REGE360 INTO @C_ARQ_E360;

     WHILE (@@FETCH_STATUS = 0) BEGIN

         INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           ('41'+RIGHT(REPLICATE('0',8)+RTRIM(@V_CONTREGE), 8), @C_ARQ_E360, @P_NRSEQARQMAG);
         SET @V_CONTREGE =  ISNULL(@V_CONTREGE,0) + 1;

         FETCH NEXT FROM C_REGE360 INTO @C_ARQ_E360;

      END;
      CLOSE C_REGE360;
      DEALLOCATE C_REGE360;
    
     FETCH NEXT FROM C_REGE300 INTO @C_ARQ_E300, @C300_DTINICIAL, @C300_DTFINAL;

   END;
   CLOSE C_REGE300;
   DEALLOCATE C_REGE300;

   DECLARE C_REGE500 CURSOR FOR (SELECT ('|E500'                                + '|' +
                                         CONVERT(VARCHAR,DTINIPERIODO,103)    + '|' +
                                         CONVERT(VARCHAR,DTFIMPERIODO,103)    + '|'  ) AS ARQ_E500,
                                         CONVERT(VARCHAR,DTINIPERIODO,103) as DTINICIAL,
                                         CONVERT(VARCHAR,DTFIMPERIODO,103) as DTFINAL
                                 FROM MAPAAPURAC
                                 WHERE CDEMPRESA     = @P_CDEMPRESA                   AND
                                       CDINSCESTA    = @P_CDINSCESTA                  AND
                                       DTINIPERIODO  = @P_DTINICIAL                   AND
                                       DTFIMPERIODO  = @P_DTFINAL                     AND
                                       CDIMPOSTO     = @P_CDIMPOSTO  )
     OPEN C_REGE500;

     FETCH NEXT FROM C_REGE500 INTO @C_ARQ_E500, @C500_DTINICIAL, @C500_DTFINAL;

     WHILE (@@FETCH_STATUS = 0) BEGIN  

         INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           ('42'+RIGHT(REPLICATE('0',8)+RTRIM(@V_CONTREGE), 8), @C_ARQ_E500, @P_NRSEQARQMAG);
         SET @V_CONTREGE =  ISNULL(@V_CONTREGE,0) + 1;
              
      DECLARE C_REGE510 CURSOR FOR (SELECT ('|E510'                                                                                  + '|' +
                                            ISNULL(N.CDFISCOPERNF, '')                                                               + '|' +
                                            ISNULL(N.IMPOS, '')                                                                      + '|' +
                                            REPLACE(LTRIM(CONVERT(VARCHAR,ISNULL(CONVERT(NUMERIC(12,2),N.VRCONTABILNF),0))),'.', ',')+ '|' +
                                            REPLACE(LTRIM(CONVERT(VARCHAR,ISNULL(CONVERT(NUMERIC(12,2),N.VRBASECALCNF),0))),'.', ',')+ '|' +
                                            ISNULL(CONVERT(VARCHAR, N.IMPOSTRIB), '')                                                                  + '|'  ) AS ARQ_E510
                                    FROM (SELECT CASE I.CDFISCALNF WHEN '1' THEN 
                                                (CASE I.VRALIQNF WHEN 0 THEN '02' ELSE '00' END)
                                                 ELSE (CASE '2' WHEN '03' THEN '3' ELSE '04' END) END  AS IMPOS,                               
                                                 I.CDFISCOPERNF, I.CDIMPOSTO,
                                                 SUM(I.VRCONTABILNF) AS VRCONTABILNF,
                                                 SUM(CASE I.CDFISCALNF WHEN '1' THEN I.VRBASECALCNF ELSE 0 END) AS VRBASECALCNF,
                                                 MAX(TEKNISA.VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, IM.CDIMPOSTRIB, 'I', I.CDFISCALNF)) AS IMPOSTRIB
                                          FROM MAPAAPURAC M, NOTAFISCAL N, IMPOSTONF I, IMPOSTO IM
                                          WHERE M.CDEMPRESA       = @P_CDEMPRESA            AND
                                                M.CDINSCESTA      = @P_CDINSCESTA           AND
                                                M.DTINIPERIODO    = @C500_DTINICIAL         AND
                                                M.DTFIMPERIODO    = @C500_DTFINAL           AND
                                                M.CDIMPOSTO       = '10'                    AND
                                                I.NRSEQUMAPAPU    = M.NRSEQUMAPAPU          AND
                                                I.CDIMPOSTO       = IM.CDIMPOSTO            AND
                                                ISNULL(I.IDIMPOSTONF, '1') <> '3'           AND
                                                N.CDFILIAL        = I.CDFILIAL              AND
                                                ISNULL(N.CDSERIE,' ')         <> 'ECF'      AND
                                                N.NRLANCTONF      = I.NRLANCTONF            AND
                                                ((N.IDSTATUS = 'A') OR (N.IDSTATUS = 'E'))
                                          GROUP BY CASE I.CDFISCALNF WHEN '1' THEN
                                                (CASE I.VRALIQNF WHEN 0 THEN '02' ELSE '00' END)
                                                 ELSE (CASE '2' WHEN '03' THEN '3' ELSE '04' END)
                                                 END , I.CDFISCOPERNF, I.CDSITUTRIBNF, I.CDIMPOSTO )N
                                    GROUP BY N.CDFISCOPERNF, N.IMPOS, N.VRCONTABILNF, N.VRBASECALCNF, N.IMPOSTRIB )
     OPEN C_REGE510;

     FETCH NEXT FROM C_REGE510 INTO @C_ARQ_E510;       

     WHILE (@@FETCH_STATUS = 0) BEGIN

         INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           ('43'+RIGHT(REPLICATE('0',8)+RTRIM(@V_CONTREGE), 8), @C_ARQ_E510, @P_NRSEQARQMAG);
         SET @V_CONTREGE =  ISNULL(@V_CONTREGE,0) + 1;
      
         FETCH NEXT FROM C_REGE510 INTO @C_ARQ_E510; 
 
      END;
      CLOSE C_REGE510;
      DEALLOCATE C_REGE510;

      DECLARE C_REGE530 CURSOR FOR (SELECT ('|E530'                                                                                                    + '|' +
                                            REPLACE(LTRIM(CONVERT(VARCHAR,ISNULL(CONVERT( NUMERIC(12,2), R.VRSLDCRANTE),0))), '.', ',')                + '|' +
                                            REPLACE(LTRIM(CONVERT(VARCHAR,ISNULL(CONVERT( NUMERIC(12,2), R.VRTOTADEBI),0))), '.', ',')                 + '|' +
                                            REPLACE(LTRIM(CONVERT(VARCHAR,ISNULL(CONVERT( NUMERIC(12,2), R.VRTOTACRED),0))), '.', ',')                 + '|' +
                                            REPLACE(LTRIM(CONVERT(VARCHAR,ISNULL(CONVERT( NUMERIC(12,2), R.VROUTRDEBI + VRESTOCRED),0))), '.', ',')    + '|' +
                                            REPLACE(LTRIM(CONVERT(VARCHAR,ISNULL(CONVERT( NUMERIC(12,2), R.VROUTRCRED + R.VRESTODEBI),0))), '.', ',')  + '|' +
                                            REPLACE(LTRIM(CONVERT(VARCHAR,ISNULL(CONVERT( NUMERIC(12,2), R.VRSALDOCRED),0))), '.', ',')                + '|' +
                                            REPLACE(LTRIM(CONVERT(VARCHAR,ISNULL(CONVERT( NUMERIC(12,2), R.VRSALDODEBI),0))), '.', ',')                + '|'  ) AS ARQ_E530
                                    FROM MAPAAPURAC M, MAPARECUP R
                                    WHERE M.CDEMPRESA       = @P_CDEMPRESA              AND
                                          M.CDINSCESTA      = @P_CDINSCESTA             AND
                                          M.DTINIPERIODO    = @C500_DTINICIAL           AND
                                          M.DTFIMPERIODO    = @C500_DTFINAL             AND
                                          M.CDIMPOSTO       = @P_CDIMPOSTO              AND
                                          R.NRSEQUMAPAPU    = M.NRSEQUMAPAPU )
     OPEN C_REGE530;
 
     FETCH NEXT FROM C_REGE530 INTO @C_ARQ_E530;

     WHILE (@@FETCH_STATUS = 0) BEGIN  

         INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           ('44'+RIGHT(REPLICATE('0',8)+RTRIM(@V_CONTREGE), 8), @C_ARQ_E530, @P_NRSEQARQMAG);
         SET @V_CONTREGE =  ISNULL(@V_CONTREGE,0) + 1;
      
         FETCH NEXT FROM C_REGE530 INTO @C_ARQ_E530;

      END;
      CLOSE C_REGE530;
      DEALLOCATE C_REGE530;

      FETCH NEXT FROM C_REGE500 INTO @C_ARQ_E500, @C500_DTINICIAL, @C500_DTFINAL;

   END;
   CLOSE C_REGE500;
   DEALLOCATE C_REGE500;

   /* abertuta do bloco E */
   IF @V_CONTREGE <> 0 BEGIN
      SET @V_MOVIMENT = 0;
   END
   ELSE BEGIN
      SET @V_MOVIMENT = 1;
   END;

   SET @V_CONTREGE = ISNULL(@V_CONTREGE,0) + 1;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     ('29'+RIGHT(REPLICATE('0',8)+RTRIM(@V_CONTREGE), 8), '|E001'+ '|' + CONVERT(VARCHAR, @V_MOVIMENT)+ '|', @P_NRSEQARQMAG);

   /* ENCERRAMENTO DO BLOCO E */
   SET @V_CONTREGE = ISNULL(@V_CONTREGE,0) + 1;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     ('45'+RIGHT(REPLICATE('0',8)+RTRIM(@V_CONTREGE), 8), '|E990'+ '|' + CONVERT(VARCHAR, @V_CONTREGE)+ '|', @P_NRSEQARQMAG);

   SET @P_RETURN = @V_CONTREGE; 
END;  
GO

-- VERSAO --
EXEC ATUVEROBJ 'ARQDIGITAL_BLOCOE','5.05.008';
GO

