CREATE TABLE PEDIDOSERV (
  NRPEDIDOSERV NUMBER(10) NOT NULL, 
  CDFILIAL VARCHAR2(4) NOT NULL, 
  CDCLIENTE VARCHAR2(21) NOT NULL, 
  DTPEDIDO DATE NOT NULL, 
  DTENTREGA DATE NOT NULL, 
  IDSTATUS VARCHAR2(30) NOT NULL, 
  NRPESSOA VARCHAR2(10) NOT NULL, 
  NRLANCTONF VARCHAR2(10) NOT NULL, 
  DSLOCALENTREGA VARCHAR2(200) DEFAULT NULL NULL, 
  NRORG NUMBER(10) DEFAULT 1 NOT NULL, 
  IDATIVO VARCHAR2(1) DEFAULT 'S' NOT NULL, 
  DTINCLUSAO DATE DEFAULT NULL NULL, 
  DTULTATU DATE DEFAULT NULL NULL, 
  NRORGINCLUSAO NUMBER(10) DEFAULT 1 NULL, 
  CDOPERINCLUSAO VARCHAR2(12) DEFAULT '1' NULL, 
  NRORGULTATU NUMBER(10) DEFAULT 1 NULL, 
  CDOPERULTATU VARCHAR2(12) DEFAULT '1' NULL,
  CONSTRAINT PK_PEDIDOSERV PRIMARY KEY(NRPEDIDOSERV, NRORG)
)
/
ALTER TABLE PEDIDOSERV ADD CONSTRAINT FKMYO00637FILIAL FOREIGN KEY (CDFILIAL, NRORG) REFERENCES FILIAL (CDFILIAL, NRORG)
/
ALTER TABLE PEDIDOSERV ADD CONSTRAINT FKMYO00638CLIENTE FOREIGN KEY (CDCLIENTE, NRORG) REFERENCES CLIENTE (CDCLIENTE, NRORG)
/
ALTER TABLE PEDIDOSERV ADD CONSTRAINT FKMYO00639PESSOA FOREIGN KEY (NRPESSOA, NRORG) REFERENCES PESSOA (NRPESSOA, NRORG)
/
ALTER TABLE PEDIDOSERV ADD CONSTRAINT FKMYO00640NOTAFISCAL FOREIGN KEY (CDFILIAL, NRLANCTONF, NRORG) REFERENCES NOTAFISCAL (CDFILIAL, NRLANCTONF, NRORG)
/
ALTER TABLE PEDIDOSERV ADD CONSTRAINT CKC_IDSTATUS_PEDIDOSERV CHECK (IDSTATUS IN ('PENDENTE','APROVADO','EMPRODUCAO','FINALIZADO','ENTREGUE'))
/
ALTER TABLE PEDIDOSERV ADD CONSTRAINT CKC_IDATIVO_PEDIDOSERV CHECK (IDATIVO IN ('S','N'))
/
CREATE INDEX MYO00637_FK ON PEDIDOSERV (CDFILIAL, NRORG)
/
CREATE INDEX MYO00638_FK ON PEDIDOSERV (CDCLIENTE, NRORG)
/
CREATE INDEX MYO00639_FK ON PEDIDOSERV (NRPESSOA, NRORG)
/
CREATE INDEX MYO00640_FK ON PEDIDOSERV (CDFILIAL, NRLANCTONF, NRORG)